unit MiniLed_Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Filter.Effects, FMX.Effects, FMX.StdCtrls, FMX.Objects, FMX.Ani,
  System.Actions, FMX.ActnList, FMX.Edit, FMX.Layouts, FMX.Memo, Xml.xmldom,
  Xml.XMLIntf, Xml.adomxmldom, Xml.XMLDoc, FMX.Gestures, System.Sensors,
  Elements,
  T_MainTl,
  e_LHCModel,
  t_ForestModelSelector,
  e_Geometry,
  FMX.ListBox, FMX.Controls3D, FMX.Objects3D, FMX.TabControl,
  FMX.Colors, System.Math.Vectors, System.Sensors.Components;

type
//{$DEFINE HK}
  RTileMatrix = record
     ID: string;
     Scale: double;
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     TileWidth: double;
     TileHeight: double;
     OverX: double;
     OverY: double;
     MatrixWidth: integer;
     MatrixHeight: integer;
  end;

  RMap = record
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     Width: double;
     Height: double;
     MapName: String;
     Ext: string;
     MapDir: string;
     TileMatrixSet: Array of RTileMatrix;
  end;


  RODD = record
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     ODD: string;
  end;

  TMainTool = class(TOldMainTool)
  public
     procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
     procedure   On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
  end;

  TMainForm = class(TForm)
    Image: TImage;
    b_plus: TButton;
    ShadowEffect1: TShadowEffect;
    XMLDocument_lhc: TXMLDocument;
    ProgressBar: TProgressBar;
    l_Progress: TLabel;
    GlowEffect1: TGlowEffect;
    b_Minus: TButton;
    ShadowEffect3: TShadowEffect;
    GestureManager1: TGestureManager;
    StyleBook1: TStyleBook;
    AniIndicator: TAniIndicator;
    LocationSensor: TLocationSensor;
    topBar: TToolBar;
    b_OpenProject: TButton;
    topbarunvisible: TButton;
    ShadowEffect5: TShadowEffect;
    Button4: TButton;
    MapCombo: TComboBox;
    b_gpsfind: TButton;
    p_FInd: TCalloutPanel;
    botbar: TToolBar;
    l_gps: TLabel;
    l_jtsk: TLabel;
    Button6: TButton;
    gpsCursor: TCircle;
    Line1: TLine;
    Line2: TLine;
    Memo: TMemo;
    XMLDocument: TXMLDocument;
    b_FindLHC: TButton;
    ShadowEffect7: TShadowEffect;
    ed_odd: TComboBox;
    ed_Dil: TComboBox;
    ed_por: TComboBox;
    ed_PSK: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ShadowEffect8: TShadowEffect;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    topbarvisible: TButton;
    botbarunvisible: TButton;
    botbarvisible: TButton;
    p_Settings: TCalloutPanel;
    cb_topbar: TSwitch;
    cb_botbar: TSwitch;
    cb_plusminus: TSwitch;
    cb_jprl: TSwitch;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Button3: TButton;
    l_JPRL: TLabel;
    b_HK: TButton;
    p_gpslog: TCalloutPanel;
    b_StartRoute: TButton;
    b_endRoute: TButton;
    Sphere1: TSphere;
    diode: TImage;
    b_TraceRoute: TButton;
    b_RoutesList: TButton;
    dlg_General: TCalloutPanel;
    dlg_Text: TLabel;
    dlg_Edit: TEdit;
    dlg_OK: TButton;
    dlg_Cancel: TButton;
    ShadowEffect2: TShadowEffect;
    ShadowEffect4: TShadowEffect;
    ShadowEffect6: TShadowEffect;
    CalloutPanel1: TCalloutPanel;
    Button1: TButton;
    Button2: TButton;
    ColorButton1: TColorButton;
    b_Note: TImage;
    l_scale: TLabel;
    GPath: TPath;
    b_view: TButton;
    ShadowEffect9: TShadowEffect;
    b_edit: TButton;
    ShadowEffect10: TShadowEffect;
    WaterTransitionEffect1: TWaterTransitionEffect;
    Panel1: TPanel;
    ImagePin: TImage;
    ImageBakule: TImage;
    b_Note_Glow: TGlowEffect;
    ActionPanel: TCalloutPanel;
    l_Caption: TLabel;
    l_Text: TLabel;
    Button5: TButton;
    p_Note: TCalloutPanel;
    p_note_Caption: TLabel;
    p_Note_Text: TLabel;
    ShadowEffect11: TShadowEffect;
    Image_edit: TImage;
    LHCListpanel: TCalloutPanel;
    LHCListbox: TListBox;
    ListBoxHeader1: TListBoxHeader;
    ShadowEffect12: TShadowEffect;
    Label9: TLabel;
    b_OpenLHC: TButton;
    Label10: TLabel;
    b_DeleteLHC: TButton;
    Label11: TLabel;
    Label12: TLabel;
    ShadowEffect13: TShadowEffect;
    GlowEffect2: TGlowEffect;
    Image1: TImage;
    procedure b_OpenProjectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageResize(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Single);
    procedure b_plusClick(Sender: TObject);
    procedure b_MinusClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure topbarunvisibleClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormGesture(Sender: TObject; const EventInfo: TGestureEventInfo;
      var Handled: Boolean);
    procedure LocationSensorLocationChanged(Sender: TObject; const OldLocation,
      NewLocation: TLocationCoord2D);
    procedure MapComboChange(Sender: TObject);
    procedure b_gpsfindClick(Sender: TObject);
    procedure b_FindLHCClick(Sender: TObject);
    procedure ed_oddChange(Sender: TObject);
    procedure ed_DilChange(Sender: TObject);
    procedure ed_porChange(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ed_PSKChange(Sender: TObject);
    procedure topbarvisibleClick(Sender: TObject);
    procedure botbarvisibleClick(Sender: TObject);
    procedure botbarunvisibleClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure cb_topbarSwitch(Sender: TObject);
    procedure cb_plusminusSwitch(Sender: TObject);
    procedure cb_botbarSwitch(Sender: TObject);
    procedure cb_jprlSwitch(Sender: TObject);
    procedure b_HKClick(Sender: TObject);
    procedure b_StartRouteClick(Sender: TObject);
    procedure b_endRouteClick(Sender: TObject);
    procedure b_TraceRouteClick(Sender: TObject);
    procedure b_RoutesListClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure dlg_CancelClick(Sender: TObject);
    procedure dlg_OKClick(Sender: TObject);
    procedure RoutesListItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure Button5Click(Sender: TObject);
    procedure b_NoteClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure b_viewClick(Sender: TObject);
    procedure l_JPRLClick(Sender: TObject);
    procedure b_editClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Image_editMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Image_editMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Single);
    procedure Image_editMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure b_OpenLHCClick(Sender: TObject);
    procedure LHCListboxItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure b_DeleteLHCClick(Sender: TObject);
  private
    { Private declarations }
    Bm: Fmx.Graphics.TBitmap;
//    G: Graphics;
    LastX,LastLocalX: Single;
    LastY,LastLocalY: Single;
    RefX: Single;
    RefY: Single;
    aX,aY: Single;
    gpsLat,gpsLong,jtskX,jtskY: double;
    MMoves: integer;
    FGPSFixed: boolean;
    CHeckJPRL: boolean;
    PreparingMove: boolean;
    BmMoving: boolean;
    BmInMove: boolean;
    BmPrepared: boolean;
    FActiveProgress: integer;
    FProc: TOwnerEntity;
    Status: integer;
    FOnSelectJPRL: TNotifyEvent;
    procedure set_GPSFixed(const Value: boolean);
    function GetProc: TOwnerEntity;
    procedure SetActiveProgress(const Value: integer);
    procedure SetProc(const Value: TOwnerEntity);
    procedure SetOnSelectJPRL(const Value: TNotifyEvent);
//    FOnSelectJPRL: EventHandler;
  public
    cbActive: boolean;
    m_Cnt: integer;
//    objParser: GpsToolsNET.NmeaParser;
    GpsOn: boolean;
    GPSTrack: boolean;
    aScale: System.Double;
    aJTSK: boolean;
//    DETshp: GpsShapeNET.ShapeFile;
//    EDITshp: GpsShapeNET.ShapeFile;
    iLHC: integer;
    iOddeleni: integer;
    iDilec: integer;
    iPorost: integer;
    iSkupina: integer;
    Moving: boolean;
    ActiveTool: integer;
    ActiveSubTool: integer;
    Fix: boolean;
    Rotate: boolean;
    ToolsMoving: boolean;
    ToolsVisible: boolean;
    ActualMap: integer;
    ActualTileMatrix: integer;
    MapChangeActive: boolean;
    Maps: Array of RMap;
    Odds: Array of RODD;
    iLastOdd: integer;
    S_rok,S_LHC,S_Oddeleni,S_Dilec,S_Porost,S_Skupina: string;
    DBPath: string;
    CloseIsVisible: boolean;
    OddListExists: boolean;
    White: boolean;
//    ObjShape: GpsShapeNET.Shape;
//    ObjMapShape: GpsViewNET.MapShape;
//    aPosition: GpsToolsNET.Position;
    Error: integer;
    Test: boolean;
    CenterX: System.Double;CenterY: System.Double;
    RealScale: System.Double;
    Scale1: System.Double;
    MinX: System.Double;MinY: System.Double;MaxX: System.Double;MaxY: System.Double;
    MultX: System.Double;MultY: System.Double;
    AddX: System.Double;AddY: System.Double;
    GpsX,GpsY: double;
    X1,Y1,X2,Y2: double;
    LastDist: integer;
    MapDirectory: string;
    Reviews: Array of Integer;
    LastReview: integer;
    BColor: TAlphaColor;
    FTestClassRef: TClass;
    ModelDET: TElement;
    MainTool: TMainTool;
    LHC: Tgis_ForestModel;
    Routes: TOwnerEntity;
    Notes: TOwnerEntity;
    LHCS: TOwnerEntity;
    ActualRoute: TPolyLineElement;
    ActualNote: TTextElement;
    RoutesPath: string;
    NotesPath: string;
    LHCSPath: string;
    AlternativeRoutesPath: string;
    AlternativeNotesPath: string;
    Routes_UseAlternative: boolean;
    FMSelector: TForestModelSelector;
    ImDrawing: boolean;
    Reviewing: boolean;
    MLine: TPolyLineElement;
   { Public declarations }
    procedure ShowScaleAndCoords;
    procedure AddProject(aFileName: string);
    procedure LoadProject(aFileName: string);
    procedure LoadMap(aFileName,aExt: string);
    procedure LoadDET(aFileName,aOddName: string);
    procedure LoadEdit(aFileName: string);
    procedure ShowTheForest;
    function  FindForestOnScreen(aPosition: TPointF; aBlink: boolean): Tgis_PorostniSkupina;
    procedure Route_StartNew;
    procedure Route_End;
    procedure Route_ShowList;
    procedure Route_StoreCoords(gx,gy: double; Redraw: boolean);
    procedure Route_UpdateList;
    procedure Route_Load;
    procedure Route_Save;
    procedure Note_UpdateList;
    procedure Note_Load;
    procedure Note_Save;
    procedure LHC_UpdateList;
    procedure LHC_Load;
    procedure LHC_Save;
    procedure CHeckActiveTool(NewActive: integer);
    function  GetExecutablePath : String;
    function  GetAbsolutePath(aRootPath,aRelativePath: string): string;
    function  FindLayerPath(aLayer: string): string;
    function  FindLayerExt(aLayer: string): string;
    function  FindLayerValue(aLayer,aValue: string): string;
    function  StopReviews: integer;  // stopne zobrazeni a vrati volnou pozici
    procedure Review(compact: boolean);
    procedure DrawRoutes;
    procedure DrawNotes;
    procedure DrawLine(aLine: TPolyElement; edit: boolean);
    procedure BlinkLine(aLine: TPolyElement);
    procedure BlinkArea(anArea: TAreaElement);
    procedure Drawgps;
    procedure CHangeProjection(_X,_Y,_Scale: double);
    procedure ChangeProjectionByFirstMapTile;
    procedure CHangeProjectionByRect(X1,Y1,X2,Y2: double);
    procedure OnSelectFile(const S: string);
    procedure AddRefClass(aValue: TClass);
    procedure Orbis_ProgressStart(_ID: Integer; ProgressName: string; MinProgress, MaxProgress, Progress: Integer);
    procedure Orbis_Progress(_ID, Value: Integer);
    procedure Orbis_ProgressEnd(_ID, Value: Integer);
    procedure Orbis_ProgressMax(_ID, Value: Integer);
    procedure Orbis_ProgressText(_ID: Integer; Value: string);
    procedure CheckProgress;
    property Proc: TOwnerEntity read GetProc write SetProc;
    property ActiveProgress: integer read FActiveProgress write SetActiveProgress;
    procedure OnProgress(_ID, _Event: integer; _Name, _Text: string; _MinValue, _MaxValue, _Progress: integer);
    function GetModelX(aPageX: Single): System.Double;
    function GetModelY(aPageY: Single): System.Double;
    function  GetPageX(aModelX: double): single;
    function  GetPageY(aModelY: double): single;
    function GetModelLength(aPageLength: single): System.Double;
    function  GetPageLength(aModelLength: double): single;
    property GPSFixed: boolean read FGPSFixed write set_GPSFixed;
    property OnSelectJPRL: TNotifyEvent read FOnSelectJPRL write SetOnSelectJPRL;
  end;

TProgressElem = class(TOwnerEntity)
  private
    FMax: integer;
    F_ID: integer;
    FMin: integer;
    FProgress: integer;
    F_Name: string;
    FText: string;
    procedure Set_ID(const Value: integer);
    procedure Set_Name(const Value: string);
    procedure SetMax(const Value: integer);
    procedure SetMin(const Value: integer);
    procedure SetProgress(const Value: integer);
    procedure SetText(const Value: string);
  published
   property _ID: integer read F_ID write Set_ID;
   property _Name: string read F_Name write Set_Name;
   property Min: integer read FMin write SetMin;
   property Max: integer read FMax write SetMax;
   property Progress: integer read FProgress write SetProgress;
   property Text: string read FText write SetText;
end;

var
  MainForm: TMainForm;


implementation
uses
//   Elements, //- + without e_Class
//   e_Class,  //-
//   u_Props,  //+
//   u_String, //+
//   TestUnit,
//   System.Typinfo, // +
//   TestScaledForm,
{$IFDEF HK}
   Main,
{$ENDIF}
   G_Elems,
   System.Diagnostics,
   Tools,
   e_Type,
   m_Orbis,
   T_loader,
   T_Saver,
   T_Coord,
   r_WGS84,
   MiniLed_Notes,
   t_XFileDialog,
   System.IOUtils;

{$R *.fmx}

procedure TMainForm.b_gpsfindClick(Sender: TObject);
begin
   if GPSFixed then
   begin
      CHangeProjection(jtskX,jtsky,RealScale);
      Review(false);
   end
   else
   begin
       ShowMessage('GPS poloha nen k dispozici');
   end;
end;

procedure TMainForm.b_MinusClick(Sender: TObject);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   X1,Y1,X2,Y2: double;
   sc, DestSc: double;
   srcScale,Step: double;
begin
   if ActiveTool = 2 then
   begin
      Image_edit.Bitmap.Canvas.BeginScene;
      Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
      Image_edit.Bitmap.Canvas.EndScene;
   end;
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Bm.BitmapScale := Image.Bitmap.BitmapScale;
   Bm.CopyFromBitmap(Image.Bitmap);
   X1 := MinX;
   Y1 := MaxY;
   X2  := MaxX;
   Y2  := MinY;
   SrcScale := RealScale;
   Sc := 1;
   DestSc := 1.5;
   Step := 0.05;
   While Sc < DestSc do
   begin
      Sc := Sc + Step;
      ChangeProjection(CenterX,CenterY,SrcScale * Sc);
      SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
      DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
      Image.Bitmap.Canvas.BeginScene;
      Image.Bitmap.Canvas.Clear(BColor);
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      Application.ProcessMessages;
   end;
//   BM.DisposeOf;
   //G := Graphics.FromImage(PictureBox1.Image);
   ChangeProjection(CenterX,CenterY,SrcScale * 1.5);
   Review(false);
   if ActiveTool = 2 then
   begin
      DrawLine(MLine,true);
   end;
end;

procedure TMainForm.b_plusClick(Sender: TObject);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   X1,Y1,X2,Y2: double;
   sc, DestSc: double;
   srcScale,Step: double;
begin
   if ActiveTool = 2 then
   begin
      Image_edit.Bitmap.Canvas.BeginScene;
      Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
      Image_edit.Bitmap.Canvas.EndScene;
   end;
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Bm.BitmapScale := Image.Bitmap.BitmapScale;
   Bm.CopyFromBitmap(Image.Bitmap);
   X1 := MinX;
   Y1 := MaxY;
   X2  := MaxX;
   Y2  := MinY;
   SrcScale := RealScale;
   Sc := 1;
   DestSc := 1.5;
   Step := 0.1;
   While Sc < DestSc do
   begin
      Sc := Sc + Step;
      ChangeProjection(CenterX,CenterY,SrcScale / Sc);
      SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
      DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
      Image.Bitmap.Canvas.BeginScene;
      Image.Canvas.Clear(BColor);
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      Application.ProcessMessages;
   end;
   BM.DisposeOf;
   //G := Graphics.FromImage(PictureBox1.Image);
   ChangeProjection(CenterX,CenterY,SrcScale / 1.5);
   Review(false);
   if ActiveTool = 2 then
   begin
      DrawLine(MLine,true);
   end;
end;

procedure TMainForm.b_RoutesListClick(Sender: TObject);
begin
   MiniLed_Notes_Form.Show;
//   Tabs.Visible := not Tabs.Visible;
//   if Tabs.Visible then
//   begin
//      b_RoutesList.Text := 'Zavt seznam GPS tras a poznmky';
//   end
//   else
//   begin
//      b_RoutesList.Text := 'Seznam GPS tras a poznmky';
//   end;
end;

procedure TMainForm.b_StartRouteClick(Sender: TObject);
begin
   if GPSFixed then
   begin
      Diode.Opacity := 1;
      b_StartRoute.Enabled := false;
      b_EndRoute.Enabled := true;
//      LocationSensor.Distance := 1;
      Route_StartNew;
//      gpsCursor.Visible := false;
      ImDrawing := false;
   end
   else
   begin
       ShowMessage('GPS poloha nen k dispozici');
   end;

end;

procedure TMainForm.cb_botbarSwitch(Sender: TObject);
begin
   if not cbActive then exit;
   botBar.Visible := cb_botbar.IsChecked;
   botbarvisible.Visible := not botBar.Visible;
end;

procedure TMainForm.cb_jprlSwitch(Sender: TObject);
begin
   if not cbActive then exit;
   CHeckJPRL := cb_jprl.IsChecked;
   l_JPRL.Visible := CHeckJPRL;
end;

procedure TMainForm.cb_plusminusSwitch(Sender: TObject);
begin
   if not cbActive then exit;
   b_plus.Visible := cb_plusminus.IsChecked;
   b_minus.Visible := cb_plusminus.IsChecked;
end;

procedure TMainForm.cb_topbarSwitch(Sender: TObject);
begin
   if not cbActive then exit;
   topBar.Visible := cb_topbar.IsChecked;
   topbarvisible.Visible := not topBar.Visible;
end;

procedure TMainForm.AddProject(aFileName: string);
var
   SE: TStringElement;
   i: integer;
begin
   if LHCS = nil then
   begin
      LHCS := TOwnerEntity.Create;
      LHCS.Name := 'LHCS';
   end;
   for i := 0 to LHCS.LastIndex do
   begin
      SE := TStringELement(LHCS.Elements[i]);
      if SE.Text = aFIleName then
      begin
         ShowMessage('LHC u bylo pidno ....');
         Exit;
      end;
   end;
   SE := TStringElement.Create;
   SE.Name := TPath.GetFileNameWithoutExtension(aFileName);
   SE.Text := aFileName;
   LHCS.AddElement(SE);
   LHC_UpdateList;
   LHC_Save;
end;

procedure TMainForm.AddRefClass(aValue: TClass);
begin
   FTestClassRef := aValue;
end;

procedure TMainForm.BlinkArea(anArea: TAreaElement);
var
   A1,A,B: TPointF;
   ai: integer;
   MA: TMultiAreaElement;
   Area: TAreaElement;
   aPath: TPathData;

   procedure FillAre(anA: TAreaElement);
   var
      ci: integer;
      L: TPolyLineElement;
      cX,cY: single;
   begin
      for ci := 0 to anA.LastIndex do
      begin
         if ci = 0 then
         begin
            A.X := GetPageX(anA.Xi[ci]);
            A.Y := GetPageY(anA.Yi[ci]);
            aPath.MoveTo(A);
            A1 := A;
         end
         else
         begin
            B.X := GetPageX(anA.Xi[ci]);
            B.Y := GetPageY(anA.Yi[ci]);
            if B.Distance(A) > 2 then
            begin
               aPath.LineTo(B);
               A := B;
            end;
         end;
      end;
      aPath.LineTo(A1);
   end;

   procedure BlinkAre(anAre: TAreaElement);
   var
      i: integer;
      Hole: TAreaElement;
   begin
      if anAre is TPolyLineAreaElement then
         Area := TPolyLineAreaElement(anAre).CreateAreaElement
      else
         Area := anAre;
      FillAre(Area);
      if Area.Holes <> nil then
      if Area.Holes.Count > 0 then
      for i := 0 to Area.Holes.LastIndex do
      begin
         Hole := TAreaElement(Area.Holes.Elements[i]);
         FillAre(Hole);
      end;

   end;
begin
   if ImDrawing then exit;
   ImDrawing := true;
   Image.Bitmap.Canvas.BeginScene;
   aPath := TPathData.Create;
   Image.Bitmap.Canvas.Fill.Kind := TBrushKind.Solid;
   Image.Bitmap.Canvas.Fill.Color := TAlphaColors.Black;
   aPath.Clear;
   try
   if anArea is TMultiAreaElement then
   begin
      MA := TMultiAreaElement(anArea);
      for ai := 0 to MA.LastIndex do
         BlinkAre(TAreaElement(MA.Elements[ai]));
   end
   else
      BlinkAre(anArea);
   A.X := 0;
   A.Y := 0;
   aPath.MoveTo(A);
   A.X := Image.Bitmap.Width;
   aPath.LineTo(A);
   A.Y := Image.Bitmap.Height;
   aPath.LineTo(A);
   A.X := 0;
   aPath.LineTo(A);
   A.Y := 0;
   aPath.LineTo(A);
   Image.Bitmap.Canvas.FillPath(aPath, 0.7);
   Image.Bitmap.Canvas.Stroke.Color := TAlphacolors.Red;
   Image.Bitmap.Canvas.Stroke.Join := TStrokeJoin.sjRound;
   Image.Bitmap.Canvas.Stroke.Dash := TStrokeDash.Solid;
   Image.Bitmap.Canvas.Stroke.Cap := TStrokeCap.scRound;
   Image.Bitmap.Canvas.Stroke.Kind := TBrushKind.Solid;
   Image.Bitmap.Canvas.DrawPath(aPath,1);
   Image.Bitmap.Canvas.EndScene;
   Application.ProcessMessages;
   finally
      ImDrawing := false;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.BlinkLine(aLine: TPolyElement);
var
   A,B: TPointF;
   i: integer;
begin
   if ImDrawing then exit;
   if aLine.CoordsCount < 2 then exit;
   ImDrawing := true;
   GPath.Align := TAlignLayout.Contents;
   GPath.Data.Clear;
   GPath.Fill := TBrush.Create(TBrushKind.None, $0);
   try
   for i := 0 to aLine.CoordsCount - 1 do
   begin
      if i = 0 then
      begin
         A.X := GetPageX(aLine.Xi[i]);
         A.Y := GetPageY(aLine.Yi[i]);
         GPath.Data.MoveTo(A);
      end
      else
      begin
         B.X := GetPageX(aLine.Xi[i]);
         B.Y := GetPageY(aLine.Yi[i]);
         if B.Distance(A) > 2 then
         begin
//            Image.Bitmap.Canvas.DrawLine(A,B,1);
            GPath.Data.LineTo(B);
//            A.X := B.X;
//            A.Y := B.Y;
         end;
      end;
   end;
   GPath.RecalcUpdateRect;
   for i := 0 to 30 do
   begin
      GPath.Visible := true;
      Application.ProcessMessages;
      Gpath.Visible := false;
      Application.ProcessMessages;
   end;
   finally
   ImDrawing := false;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.botbarunvisibleClick(Sender: TObject);
begin
   botbar.Visible := false;
   botbarvisible.visible := True;
end;

procedure TMainForm.botbarvisibleClick(Sender: TObject);
begin
   botbar.Visible := true;
   botbarvisible.visible := false;
end;

procedure TMainForm.Button10Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualDilec;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
   end;
end;

procedure TMainForm.Button11Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualPorost;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
   end;
end;

procedure TMainForm.Button12Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualSkupina;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
   end
   else
   begin
       ShowMessage('PSK neni');
   end;
end;

procedure TMainForm.b_DeleteLHCClick(Sender: TObject);
var
   LI: TListBoxItem;
   SE: TStringElement;
begin
   LI := LHCListbox.Selected;
   if LI <> nil then
   begin
       SE :=  TStringElement(LI.Data);
       LHCs.ElementToFree := SE;
       LHC_Save;
       LHC_UpdateList;
   end;
end;

procedure TMainForm.b_editClick(Sender: TObject);
begin
   Image_edit.Visible := true;
   MLine := TPolyLineElement.Create;
   if ActiveTool = 2 then
   begin
      Image_edit.Bitmap.Canvas.BeginScene;
      Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
      Image_edit.Bitmap.Canvas.EndScene;
      exit;
   end;
   Image_edit.Bitmap.Resize(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
   Image_edit.Bitmap.Canvas.BeginScene;
//   Image_edit.Bitmap.CopyFromBitmap(Image.Bitmap);
   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);

//   Image_edit.Bitmap.Canvas.DrawBitmap(Image.Bitmap,RF,RF,1);
   Image_edit.Bitmap.Canvas.Stroke.Color := TAlphacolors.Red;
   Image_edit.Bitmap.Canvas.Stroke.Join := TStrokeJoin.sjRound;
   Image_edit.Bitmap.Canvas.Stroke.Dash := TStrokeDash.Solid;
   Image_edit.Bitmap.Canvas.Stroke.Cap := TStrokeCap.scRound;
   Image_edit.Bitmap.Canvas.Stroke.Kind := TBrushKind.Solid;
   Image_edit.Bitmap.Canvas.StrokeThickness := 5;
//   Image_edit.Bitmap.Canvas.DrawLine(TPointF.Create(0,0),TPointF.Create(200,200),1);
   Image_edit.Bitmap.Canvas.EndScene;
   ActiveTool := 2;
   ActionPanel.Visible := true;
   l_Caption.Text := 'Men vzdlenosti/plochy';
   l_Text.Text := 'Reim men ukonte zavenm tohoto panelu...'
end;

procedure TMainForm.b_endRouteClick(Sender: TObject);
begin
   diode.Opacity := 0.1;
   b_endRoute.Enabled := false;
   b_StartRoute.Enabled := true;
   Route_End;
   dlg_Edit.Text := 'Trasa '+IntToStr(Routes.Count);
   dlg_Text.Text := 'Uloit trasu pod nzvem:';
   dlg_General.Visible := true;
end;

procedure TMainForm.b_HKClick(Sender: TObject);
begin
{$IFDEF HK}
//   Form2.Show;
//   exit;
  if not System.IOUtils.TFile.Exists(IncludeTrailingPathDelimiter(DBPath) + 'LHC_' + S_LHC + '_' + S_rok + '.s3db') then
  begin
     ShowMessage('DB daje pro LHC '+S_LHC+' a rok '+S_rok+' nejsou k dispozici.');
     exit;
  end;
//  AniIndicator.Visible := true;
//  AniIndicator.Enabled := true;
//  Application.ProcessMessages;
  try
   Form2.ZobrazHK(s_LHC,S_rok,S_Oddeleni,s_Dilec,s_Porost,S_Skupina);
  finally

  end;
//  AniIndicator.Visible := false;
//  AniIndicator.Enabled := false;
{$ELSE}
   if (LHC <> nil) and (FMSelector <> nil) then
   begin
      if FMSelector.ActualFrame <> nil then
      begin
         if Assigned(OnSelectJPRL) then
            OnSelectJPRL(FMSelector.ActualFrame)
         else
         begin
            ShowMessage('OnSelectJPRL nen obsazeno ')
         end;
      end;
   end;
{$ENDIF}
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
   dlg_Edit.Text := 'Trasa test';
   dlg_General.Visible := true;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
   ImDrawing := false;
end;

procedure TMainForm.b_TraceRouteClick(Sender: TObject);
begin
   p_gpslog.Visible := not p_gpslog.Visible;
   if p_gpslog.Visible then
   begin
      b_TraceRoute.Text := 'Zavt trasovn GPS' ;
   end
   else
   begin
      b_TraceRoute.Text := 'Trasovn GPS' ;
   end;
end;

procedure TMainForm.b_viewClick(Sender: TObject);
begin
   MiniLed_Notes_Form.Show;
end;

procedure TMainForm.b_OpenLHCClick(Sender: TObject);
begin
   XFileDialog.Filter := '.opx';
   XFileDialog.Directory := '/';
   XFileDialog.ed_Caption.Text := 'Vbr souboru projektu';
   XFileDialog.OnSelect := OnSelectFile;
//   xFileDialog.DirsOnly := true;
   XFileDialog.Show;

//   XD := TXFileDialog.Create(Application);
//   XD.Directory := '/';
//   XD.ed_Caption.Text := 'Vbr souboru projektu';
//   XD.Filter := '.opx';
//   XD.ShowModal(procedure(ModalResult: TModalResult)
//   begin
//     if ModalResult = mrOK then
//     begin
//     // if OK was pressed and an item is selected, pick it
//        edit1.Text := XD.FileName ;
//     end
//     else
//        edit1.Text := '';
//     XD.DisposeOf;
//   end);
//   if Edit1.Text <> '' then
//      LoadProject(Edit1.Text);
//
end;

procedure TMainForm.b_OpenProjectClick(Sender: TObject);
begin
{$IFDEF HK}
   LHCListpanel.Visible := true;
{$ELSE}
   XFileDialog.Filter := '.opx';
   XFileDialog.Directory := '/';
   XFileDialog.ed_Caption.Text := 'Vbr souboru projektu';
   XFileDialog.OnSelect := OnSelectFile;
//   xFileDialog.DirsOnly := true;
   XFileDialog.Show;
{$ENDIF}

end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  p_Settings.Visible := false;
end;

procedure TMainForm.topbarunvisibleClick(Sender: TObject);
var
   P1,P2: TPointF;
begin
   topbarvisible.Visible := true;
   TopBar.Visible := false;
end;

procedure TMainForm.topbarvisibleClick(Sender: TObject);
begin
   topbarvisible.Visible := false;
   TopBar.Visible := true;
end;

procedure TMainForm.Button4Click(Sender: TObject);
//var
//   En: TOwnerEntity;
//   E: TOwnerElement;
//   e: TElement;
//   i: integer;
begin
   if not GPSOn then
   begin
      GPSFixed := false;
      jtskX := 0;
      jtskY := 0;
      l_gps.Text := 'gps zapnuta, ek na signl...' ;
      LocationSensor.Active := true;
      Button4.Text := 'GPS +';
      GpsOn := true;
   end
   else
   begin
      GpsFixed := false;
      gpsCursor.Visible := false;
      l_gps.Text := 'gps vypnuta...' ;
      LocationSensor.Active := false;
      Button4.Text := 'GPS';
      GpsOn := false;
   end;
//   En := TOwnerEntity.Create;
//   for i := 0 to 10 do
//   begin
//      E := TOwnerElement.Create;
//      E.Name := 'Element '+IntToStr(i);
//      EN.AddElement(E);
////        En.AddElement(TOwnerElement.Create);
//   end;
//   Memo1.Visible := true;
//   Memo1.Lines.Clear;
//   Memo1.Lines.Add('count: ' + IntToStr(En.Count));
//   for i  := 0 to En.LastIndex do
//      memo1.Lines.Add(En.Elements[i].Name);
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
//   l_gps.Text := TPath.GetHomePath;
   p_Note.Visible := false;
   ActiveTool := 0;
   Status := 0;
   b_Note_Glow.Enabled := false;
   ActionPanel.Visible := false;
   Image_Edit.Visible := false;
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
   p_Settings.Visible := not p_Settings.Visible;
   if p_Settings.Visible then
   begin
      cbActive := false;
      cb_topbar.IsChecked := topBar.Visible;
      cb_botbar.IsChecked := botbar.Visible;
      cb_plusminus.IsChecked := b_plus.Visible;
      cb_jprl.IsChecked := CHeckJPRL;
      cbActive := true;
   end;
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
   i: integer;
   D1,D2: Int64;
   F: double;
begin

   D1 := TStopwatch.GetTimeStamp;
   for I := 0 to 1000 do
   begin
      l_scale.Text := i.ToString;
      Application.ProcessMessages;
   end;
   D2 := TStopwatch.GetTimeStamp;
   F := (D2 - D1)/1000;
   l_scale.Text := FormatFloat('0.###',F);
end;

procedure TMainForm.b_FindLHCClick(Sender: TObject);
begin
   p_FInd.Visible := not p_Find.Visible;
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
   p_FInd.Visible := false;
end;

procedure TMainForm.Button9Click(Sender: TObject);
var
   FU: Tgis_ForestUnit;
begin
   Fu := LHC.ActualOddeleni;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
   end;
end;

procedure TMainForm.CHangeProjection(_X, _Y, _Scale: double);
var
   Center_X, Center_Y,W,H: Single;
   S: string;
begin
//   l_Scale.Text := '1 : ' + IntToStr(Round(_Scale));
//   S := '0.###';
//   l_jtsk.Text := 'X: '+FormatFloat(S,_X) + ' Y: '+FormatFloat(S,_Y);
   CenterX   := _X;
   CenterY   := _Y;
   RealScale := _Scale;
   W := Image.Width;
   H := Image.Height;
   Center_X := W / 2;
   Center_Y := H / 2;
   MultX := RealScale/5333; //Resolution.x; dpi / size of inch in mm * 1000
   MultY := MultX;
   AddX := CenterX - (Center_X * MultX);
   AddY := CenterY + (Center_Y * MultY);
   MinX := GetModelX(0);
   MinY := GetModelY(H);
   MaxX := GetModelX(W);
   MaxY := GetModelY(0);
   if _Scale = Scale1 then
      aScale := 1
   else
      aScale := 2;
end;

procedure TMainForm.ChangeProjectionByFirstMapTile;
var
   MapRec : RMap;
   S: string;
   //G: Graphics;
   bm1: FMx.Graphics.TBitmap;
   DestRect,SrcRect: TRectF;
   rX,rY: integer;
   x1,y1,x2,y2: double;
   wi,hi: single;
   wd,hd: double;
begin
   if Length(Maps) < 1 then exit;
   MapRec := Maps[0];
//   //MessageBox.Show(S);
//   S := MapDirectory + MapRec.MapName;
   try
////   MessageBox.Show(S);
////   exit;
//   //if BM <> nil then
//   //  BM.Dispose;
////   ShowMessage('load bmp');
//   Bm1 := FMX.Graphics.TBitmap.CreateFromFile(S);
//   Image.Bitmap.Canvas.BeginScene;
////   ShowMessage('clear');
//   Image.Bitmap.Canvas.Clear(BColor);
//   aScale := 1;
//   SrcRect.Create(0,0,Bm1.Width,Bm1.Height);
//   DestRect.Create(RefX,RefY,RefX + (Bm1.Width / Image.Canvas.Scale),RefY + (Bm1.Height / Image.Canvas.Scale));
//
////   ShowMessage('draw');
//
//   Image.Bitmap.Canvas.DrawBitmap(Bm1,SrcRect,DestRect,100);
//   Image.Bitmap.Canvas.EndScene;
////   PaintBox.BitmapChanged;
//   wi := Image.Width;
//   hi := Image.Height;
//   if BM1.Width < wi then
//      wi := BM1.Width;
//   if BM1.Height < hi then
//      hi := BM1.Height;
//   WD := MapRec.MaxX - MapRec.MinX;
//   HD := MapRec.MaxY - MapRec.MinY;
   x1 := MapRec.MinX;
   Y1 := MapRec.MinY;
//   Y1 := Y2 - hD / BM1.Height * hi;
//   x2 := X1 + wd / BM1.Width  * wi;
   x2 := MapRec.MaxX;
   Y2 := MapRec.MaxY;

//   Bm1.DisposeOf;
//   ShowMessage('Chng proje');
   CHangeProjectionByRect(X1,Y1,X2,Y2);
   Scale1 := RealScale;
   //PictureBox1.Image := System.Drawing.Bitmap.Create(S);
//   ShowMessage('After Chng proje');
   finally
//      ShowMessage('ups');
   end;
end;

procedure TMainForm.CHangeProjectionByRect(X1, Y1, X2, Y2: double);
var
   _x,_y: double;
   _Scale: double;
   ScaleX: double;
   ScaleY: double;
   dX,dY: double;
begin
   dX := X2 - X1;
   dY := Y2 - Y1;
   try
     ScaleX := dX/(Image.Width/5333);
     ScaleY := dY/(Image.Height/5333);
     if ScaleX > ScaleY then _Scale := ScaleX
                        else _Scale := ScaleY;
     _x :=  X1 + dX/2;
     _y :=  Y1 + dY/2;
     ChangeProjection(_X,_Y, _Scale)
   except
   end
end;

procedure TMainForm.CHeckActiveTool(NewActive: integer);
begin

end;

procedure TMainForm.CheckProgress;
var
   i: integer;
   PE: TProgressElem;
begin
   exit;
   if Proc.NoElements then
   begin
      ProgressBar.Visible := false;
      l_Progress.Visible := false;
      Memo.Lines.Clear;
      Memo.Visible := false;
   end
   else
   begin
      ProgressBar.Visible := true;
      l_Progress.Visible := true;
      Memo.Visible := true;
      Memo.Lines.Clear;
      Memo.Lines.Add('      PROGRESS ');
      Memo.Lines.Add('------------------------');
      for i := 0 to Proc.LastIndex do
      begin
         PE := TProgressElem(Proc.Elements[i]);
         Memo.Lines.Add(PE._Name+' '+IntToStr(PE.Min)+'/'+IntToStr(PE.Progress)+'/'+IntToStr(PE.Max)+' '+PE.Text);
         Memo.Lines.Add('------------------------');
      end;
      Application.ProcessMessages;
   end;

end;

procedure TMainForm.dlg_CancelClick(Sender: TObject);
begin
   case Status of
      0:
      begin
         Routes.FreeElement(ActualRoute);
      end;
      1:
      begin
         ActualRoute := nil;
         Status := 0;
         ImageBakule.Visible := false;
      end;
   end;
   dlg_General.Visible := false;
end;

procedure TMainForm.dlg_OKClick(Sender: TObject);
var
   T: TTextElement;
begin
   case Status of
      0:
      begin
         ActualRoute.Name := dlg_Edit.Text;
         Route_UpdateList;
         Route_Save;
      end;
      1:
      begin
         if Notes = nil then
         begin
            Notes := TOwnerEntity.Create;
            Notes.Name := 'Notes';
         end;
         Status := 0;
         T := ActualNote;
//         T.Name := 'Poznmka';
         T.Text := dlg_Edit.Text;
         Notes.AddElement(T);
         ImageBakule.Visible := false;
         Note_UpdateList;
         Note_Save;
         DrawNotes;
      end;
   end;
   dlg_General.Visible := false;
end;

procedure TMainForm.Drawgps;
var
   sX,sY: single;
begin
   if GPSFixed then
   begin
      if (jtskX < MaxX) and (jtskX > MinX) and (jtskY < MaxY) and (jtskY > MinY) then
      begin
         gpsCursor.Visible := true;
         sX := GetPageX(jtskX);
         sY := GetPageY(jtskY);
         gpsCursor.Position.X := sX - (gpsCursor.Width / 2);
         gpsCursor.Position.Y := sY - (gpsCursor.Height / 2);
      end
      else
      begin
         gpsCursor.Visible := false;
      end;
   end;
end;

procedure TMainForm.DrawLine(aLine: TPolyElement; edit: boolean);
var
   A,B: TPointF;
   i: integer;
   Path: TPathData;
   aCanvas: TCanvas;
begin
   if ImDrawing then exit;
   if aLine.CoordsCount < 2 then exit;
   ImDrawing := true;
   Path := TPathData.Create;
   try
   if Edit then
      aCanvas := Image_Edit.Bitmap.Canvas
   else
      aCanvas := Image.Bitmap.Canvas;
   aCanvas.BeginScene;
   aCanvas.Stroke.Color := TAlphacolors.Red;
   aCanvas.Stroke.Join := TStrokeJoin.sjRound;
   aCanvas.Stroke.Dash := TStrokeDash.Solid;
   aCanvas.Stroke.Cap := TStrokeCap.scRound;
   aCanvas.Stroke.Kind := TBrushKind.Solid;
   aCanvas.StrokeThickness := 5;
   for i := 0 to aLine.CoordsCount - 1 do
   begin
      if i = 0 then
      begin
         A.X := GetPageX(aLine.Xi[i]);
         A.Y := GetPageY(aLine.Yi[i]);
         Path.MoveTo(A);
      end
      else
      begin
         B.X := GetPageX(aLine.Xi[i]);
         B.Y := GetPageY(aLine.Yi[i]);
         if B.Distance(A) > 2 then
         begin
//            Image.Bitmap.Canvas.DrawLine(A,B,1);
            Path.LineTo(B);
//            A.X := B.X;
//            A.Y := B.Y;
         end;
      end;
   end;
   aCanvas.DrawPath(Path,1);
   finally
   aCanvas.EndScene;
   ImDrawing := false;
   Path := nil;
   end;
//   Application.ProcessMessages;
end;

procedure TMainForm.DrawNotes;
var
   DestRect,SrcRect: TRectF;
   i: integer;
   T: TTextElement;
   XX,YY: single;
   P1,P2: TPointF;
begin
   if (Notes =  nil) or Notes.NoElements  then exit;
   Image.Bitmap.Canvas.BeginScene;
   for i := 0 to Notes.LastIndex do
   begin
      T := TTextElement(Notes.Elements[i]);
      if T.IsOverRegion(MinX,MinY,MaxX,MaxY) then
      begin
         XX := GetPageX(T.X);
         YY := GetPageY(T.Y);
         P1.X := XX - 20;
         P1.Y := YY;
         P2.X := XX + 20;
         P2.Y := YY;
         Image.Bitmap.Canvas.DrawLine(P1,P2,1);
         P1.X := XX;
         P1.Y := YY - 20;
         P2.X := XX;
         P2.Y := YY + 20;
         Image.Bitmap.Canvas.DrawLine(P1,P2,1);
         XX := XX - ((ImageBakule.Width{ * Image.Canvas.Scale}) /2);
         YY := YY - (ImageBakule.Height{ * Image.Canvas.Scale});
         SrcRect  := TRectF.Create(0,0,ImageBakule.Bitmap.Width,ImageBakule.Bitmap.Height);
         DestRect := TRectF.Create(XX,YY,XX+ImageBakule.Width,YY + ImageBakule.Height);
         Image.Bitmap.Canvas.DrawBitmap(ImageBakule.Bitmap,SrcRect,DestRect,1);
      end;
   end;
   Image.Bitmap.Canvas.EndScene;
end;

procedure TMainForm.DrawRoutes;
var
   i: integer;
   e: TElement;
   L: TPolyLineElement;
begin
   if Routes = nil then exit;
   for i := 0 to Routes.LastIndex do
   begin
      e := Routes.Elements[i];
      if not (e is TPolyLineElement) then continue;
      L := TPolyLineElement(E);
      DrawLine(L,false);
   end;
end;

procedure TMainForm.ed_DilChange(Sender: TObject);
var
   i: integer;
begin
   if ed_Dil.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Dilec_Name := ed_DIL.Items[ed_DIL.ItemIndex];
      ed_Por.Items.Clear;
      if (LHC.ActualDilec <> nil) and not LHC.ActualDilec.NoItems then
      begin
         for I := 0 to LHC.ActualDilec.Items.LastIndex do
         begin
             ed_Por.Items.Add(LHC.ActualDilec.Items.Elements[i].Name);
         end;
         ed_Por.ItemIndex := -1;
         ed_Por.ItemIndex := 0;
      end;
   end;
end;

procedure TMainForm.ed_oddChange(Sender: TObject);
var
   odd: integer;
   i: integer;
begin
   if ed_Odd.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Oddeleni_Cislo := StrToIntDef(ed_ODD.Items[ed_Odd.ItemIndex],0);
      ed_Dil.Items.Clear;
      if (LHC.ActualOddeleni <> nil) and not LHC.ActualOddeleni.NoItems then
      begin
         for I := 0 to LHC.ActualOddeleni.Items.LastIndex do
         begin
             ed_Dil.Items.Add(LHC.ActualOddeleni.Items.Elements[i].Name);
         end;
         ed_DIl.ItemIndex := -1;
         ed_DIl.ItemIndex := 0;
      end;
   end;
end;

procedure TMainForm.ed_porChange(Sender: TObject);
var
   i: integer;
begin
   if ed_POR.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Porost_Name := ed_Por.Items[ed_Por.ItemIndex];
      ed_PSK.Items.Clear;
      if (LHC.ActualPorost <> nil) and not LHC.ActualPorost.NoItems then
      begin
         for I := 0 to LHC.ActualPorost.Items.LastIndex do
         begin
             ed_PSK.Items.Add(LHC.ActualPorost.Items.Elements[i].Name);
         end;
         ed_PSK.ItemIndex := -1;
         ed_PSK.ItemIndex := 0;
      end;
   end;
end;

procedure TMainForm.ed_PSKChange(Sender: TObject);
var
   i: integer;
begin
   if ed_PSK.ItemIndex < 0 then exit;
   if LHC <> nil then
   begin
      LHC.Skupina_Name := ed_PSK.Items[ed_PSK.ItemIndex];
      if LHC.ActualLHC <> nil then  S_LHC := LHC.ActualLHC.Name;
      if LHC.ActualOddeleni <> nil then S_Oddeleni := LHC.ActualOddeleni.Name;
      if LHC.ActualDilec <> nil then S_Dilec := LHC.ActualDilec.Name;
      if LHC.ActualPorost <> nil then S_Porost := LHC.ActualPorost.Name;
      if LHC.ActualSkupina <> nil then S_Skupina := LHC.ActualSkupina.Name;
   end;
end;

function TMainForm.FindForestOnScreen(aPosition: TPointF; aBlink: boolean): Tgis_PorostniSkupina;
var
   _X,_Y: double;
   XX,YY: single;
   PSK: Tgis_PorostniSkupina;
begin
   result := nil;
   if (LHC <> nil) and (FMSelector <> nil) then
   begin
       _X := GetModelX(aPosition.X);
       _Y := GetModelY(aPosition.Y);
       XX := aPosition.X;
       YY := aPosition.Y;

       if not FMSelector.Busy then
       begin
          FMSelector.X := _X;
          FMSelector.Y := _Y;
          FMSelector.DoIt;
          if FMSelector.ActualFrame <> nil then
          begin
             PSK := Tgis_PorostniSkupina(FMSelector.ActualFrame);
             result := PSK;
             if aBlink  then
                BlinkArea(TAreaElement(PSK.Geometry));
             S_LHC := IntToStr(PSK.LHC);
             S_Oddeleni := IntToStr(PSK.Oddeleni);
             S_Dilec := PSK._Dilec.Name;
             S_Porost := PSK._Porost.Name;
             S_Skupina := PSK.Name;
             l_JPRL.Text := {S_LHC+' '+}S_Oddeleni+S_Dilec+S_Porost+' '+S_Skupina;
          end
          else
          begin
             l_jprl.Text := 'JPRL?';
          end;
       end;
   end;
end;

function TMainForm.FindLayerExt(aLayer: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes['Ext'].Text;
     end;
  end;
end;

function TMainForm.FindLayerPath(aLayer: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes['File'].Text;
     end;
  end;
end;

function TMainForm.FindLayerValue(aLayer, aValue: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes[aValue].Text;
     end;
  end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
   ImageBakule.Visible := false;
   Status := 0;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   i: integer;
begin
//   {$IFNDEF HK}
//   b_HK.Visible := false;
//   {$ENDIF}
//   Routes_UseAlternative := true;
   Status := 0;
   ImDrawing := false;
   Reviewing := false;
   Test := true;
   CHeckJPRL := true;
   ActualMap := 0;
   ActualTileMatrix := 0;
   MapChangeActive := false;
   Moving := false;
   bmMoving := true;
   bmInMove := false;
   Fix := false;
   GPSFixed := false;
   ToolsMoving := false;
   ToolsVisible := true;
   Rotate := false;
   iLastOdd := -1;
   BColor := TAlphaColors.Black;
   Image.Bitmap.Resize(Round(Image.Width * Image.Canvas.Scale),Round(Image.Height * Image.Canvas.Scale));
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image.Bitmap := TBitmap.Create(Round(Image.Width {* Image.Scene.GetSceneScale}),Round(Image.Height{ * Image.Scene.GetSceneScale}));
//   Image.Bitmap.BitmapScale := 1;
//   Edit1.Text := IntToStr(Round(Image.AbsoluteWidth))+'x'+IntToStr(Round(Image.AbsoluteHeight))+'('+IntToStr(Round(Width))+'x'+IntToStr(Round(Height))+') scale Scene: '+IntToStr(Round(Image.Scene.GetSceneScale))+' canvas: '+IntToStr(Round(Image.Canvas.Scale));
//   iScene.
   RefX := 0;
   RefY := 0;
   LastX := 0;
   LastY := 0;
   aScale := 1;
   ActiveTool := 0;
   SetLength(Reviews,20);
   for i  := 0 to Length(Reviews) - 1 do Reviews[i] := 0;

   LastReview := 0;
   aJTSK := false;
   MainTool := TMainTool.Create;
{$IFDEF MSWINDOWS}
   MainTool.CreateWorld(Self);
{$ELSE}
   MainTool.CreateWorld;
{$ENDIF}
   MainTool.On_Progress_Event := OnProgress ;
{$IFDEF HK}
   LHCListPanel.Align := TAlignLayout.Contents;
   LHCSPath := TPath.Combine(TPath.GetHomePath,'LHCS.orb');
   LHC_Load;
{$ELSE}
   LHCListpanel.Visible := false;
{$ENDIF}
   Application.ProcessMessages;
end;

procedure TMainForm.FormGesture(Sender: TObject; const EventInfo: TGestureEventInfo; var Handled: Boolean);
var
   DestRect,SrcRect: TRectF;
   _X,_Y: double;
   i: integer;
   dX,dY,XX,YY: single;
   S: string;
   A,B: TPointF;
   PSK: Tgis_PorostniSkupina;
   T: TTextElement;
   P1,P2: TPointF;
begin
   if Reviewing then exit;
//   if ActiveTool > 0 then exit;

   GPath.Visible := false;
   if EventInfo.GestureID = igiZoom then
   begin
      if (TInteractiveGestureFlag.gfBegin in EventInfo.Flags)then
      begin
           p_Note.Visible := false;

           StopReviews;
//           if Test then Memo1.Lines.Add('G Z B');
//         exit;
//         if not BmPrepared then
//         begin
//            Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
            if BmInMove then
            begin
//              if Test then Memo1.Lines.Add('BMIM');
               bmInMove := false;
               RefX := RefX + aX;
               RefY := RefY + aY;
               _X := GetModelLength(aX);
               _Y := GetModelLength(aY);
               CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
               //G.Dispose;
               LastX := 0;
               LastY := 0;
//               Review(false);
               PreparingMove := false;
            end;

//            bmMoving := true;
//            Bm.CopyFromBitmap(Image.Bitmap);
            X1 := MinX;
            Y1 := MaxY;
            X2 := MaxX;
            Y2 := MinY;
//            BMPrepared := true;
//         end;
//            Bm.CopyFromBitmap(Image.Bitmap);
      end
      else
      if (TInteractiveGestureFlag.gfEnd in EventInfo.Flags) then
      begin
//         if Test then Memo1.Lines.Add('G Z E');
//         exit;
//         BM.DisposeOf;
         //G := Graphics.FromImage(PictureBox1.Image);
  //       ChangeProjection(CenterX,CenterY,SrcScale * 1.5);
//         BmPrepared := false;
         Review(false);
         ShowScaleAndCoords;
      end
      else
      begin
//         if Test then Memo1.Lines.Add('G Z *****');
//         exit;
//         if not  BmPrepared then
//            exit;
         dX := EventInfo.Location.X - (Image.Width / 2);
         dY := EventInfo.Location.Y - (Image.Height / 2);
         _X := GetModelX(EventInfo.Location.X);
         _Y := GetModelY(EventInfo.Location.Y);
         ChangeProjection(CenterX,CenterY,RealScale / (EventInfo.Distance / LastDist));
         _X := _X - GetModelLength(dX);
         _Y := _Y + GetModelLength(dY);
         ChangeProjection(_X,_Y,RealScale);
         SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
         DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
         Image.Bitmap.Canvas.BeginScene;
         Image.Bitmap.Canvas.Clear(BColor);
         Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
//         A.X := EventInfo.Location.X - 10;
//         B.X := EventInfo.Location.X + 10;
//         A.Y := Eventinfo.Location.Y;
//         B.Y := Eventinfo.Location.Y;
//         Image.Bitmap.Canvas.DrawLine(A,B,1);
//         A.X := EventInfo.Location.X;
//         B.X := EventInfo.Location.X;
//         A.Y := Eventinfo.Location.Y - 10;
//         B.Y := Eventinfo.Location.Y + 10;
//         Image.Bitmap.Canvas.DrawLine(A,B,1);
         Image.Bitmap.Canvas.EndScene;
         Application.ProcessMessages;
      end;
      LastDist := EventInfo.Distance;
   end
   else
   if EventInfo.GestureID = igiPan then
   begin
//      exit;
      if (TInteractiveGestureFlag.gfBegin in EventInfo.Flags)then
      begin
//         Memo1.Lines.Add('G P B');
//         exit;
//         p_Note.Visible := false;
         StopReviews;
         LastX := EventInfo.Location.X;
         LastY := EventInfo.Location.Y;
         LastLocalX := EventInfo.Location.X;
         LastLocalY := EventInfo.Location.Y;
//         if not BmPrepared then
//         begin
//            PreparingMove := true;
//    //         Memo1.Lines.Add('down --------') ;
//            Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//            Bm.CopyFromBitmap(Image.Bitmap);
//            //G := Graphics.FromImage(PictureBox1.Image);
//            PreparingMove := false;
//            BmPrepared := true;
//         end;
      end
      else
      if (TInteractiveGestureFlag.gfEnd in EventInfo.Flags) then
      begin
//         Memo1.Lines.Add('G P E');
//         exit;
//         Bm.DisposeOf;
//         BmPrepared := false;
         RefX := RefX + aX;
         RefY := RefY + aY;
         _X := GetModelLength(aX);
         _Y := GetModelLength(aY);
         CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
         //G.Dispose;
         LastX := 0;
         LastY := 0;
         Review(false);
         ShowScaleAndCoords;
//         bmMoving := false;
//         PreparingMove := false;
      end
      else
      begin
//         exit;
         S := '0';
//         Edit1.Text := 'x:'+FormatFloat(S,EventInfo.Location.X)+' y:'+FormatFloat(S,EventInfo.Location.Y);
//         Memo1.Lines.Insert(0,'G P '+'x:'+FormatFloat(S,EventInfo.Location.X)+' y:'+FormatFloat(S,EventInfo.Location.Y));
//         exit;
            S := '0';
//            Edit1.Text := 'x:'+FormatFloat(S,EventInfo.Location.X)+' y:'+FormatFloat(S,EventInfo.Location.Y);
//            Application.ProcessMessages;
//         if not BmPrepared then  exit;
//
//         if BmMoving then exit;
//         BmMoving := true;
         i := ActiveTool;//c_Action.SelectedIndex;
         case i of
            0,1:
            begin
            try
//            if PreparingMove then exit;

            if (LastLocalX = EventInfo.Location.X) and (LastLocalY = EventInfo.Location.Y)  then exit;
      //      Memo1.Lines.Add('Move');
            if p_Note.Visible then
            begin
               p_Note.Position.X := p_Note.Position.X + EventInfo.Location.X - LastLocalX;
               p_Note.Position.y := p_Note.Position.Y + EventInfo.Location.Y - LastLocalY;
            end;
            if ImageBakule.Visible then
            begin
               ImageBakule.Position.X := ImageBakule.Position.X + EventInfo.Location.X - LastLocalX;
               ImageBakule.Position.y := ImageBakule.Position.Y + EventInfo.Location.Y - LastLocalY;
            end;

            LastLocalX := EventInfo.Location.X;
            LastLocalY := EventInfo.Location.Y;
            _X := GetModelX(EventInfo.Location.x);
            _Y := GetModelY(EventInfo.Location.Y);
      //      S := '0.##';
      //      l_Coords.Text := 'x:'+FormatFloat(S,_X)+' y:'+FormatFloat(S,_Y);

            //l_xy.Text := e.x.ToString + ',' + e.Y.ToString;
            //G.Clear(0);
            //G.Clear(Color.WhiteSmoke);
            Image.Bitmap.Canvas.BeginScene;
            Image.Bitmap.Canvas.Clear(BColor);
            aX := EventInfo.Location.X - LastX;
            aY := EventInfo.Location.Y - LastY;
      //      Image.Bitmap.Canvas.DrawLine(TPointF.Create(LastLocalX,LastLocalY),TPointF.Create(X,Y),100);
      //      LastLocalX := X;
      //      LastLocalY := Y;
            SrcRect.Create(0,0,Bm.Width,Bm.Height);
            DestRect.Create(aX,aY,aX + (Bm.Width / Image.Canvas.Scale),aY + (Bm.Height / Image.Canvas.Scale));
            Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,100);
            Image.Bitmap.Canvas.EndScene;
            Application.ProcessMessages;
            finally

            end;
            end;
         end;
//         BmMoving := false;
      end;
      LastDist := EventInfo.Distance;
   end
   else
   if EventInfo.GestureID = igiLongTap then
   begin
      if ActiveTool = 1 then
      begin
         if Status > 0 then exit;
         // hledani poznamky
         if Notes = nil then
         begin
            Notes := TOwnerEntity.Create;
            Notes.Name := 'Notes';
         end;
         for i := 0 to Notes.LastIndex do
         begin
            T := TTextElement(Notes.Elements[i]);
            A.X := GetPageX(T.X);
            A.Y := GetPageY(T.Y);
            if A.Distance(EventInfo.Location)  < 20 then
            begin
               p_Note.Visible := true;
               p_note_Caption.Text := T.Name;
               p_Note_Text.Text := T.Text;
               p_Note.Position.X := A.X - p_Note.Width/2;
               p_Note.Position.Y := A.Y + 5;
               exit;
            end;
         end;
         p_Note.Visible := false;
         Status := 1;
         PSK := FindForestOnScreen(EventInfo.Location,false);
         if PSK <> nil then
            S := (S_Oddeleni + S_Dilec + S_Porost + ' ' + S_Skupina)
         else
            S := 'Mimo les';
         XX := EventInfo.Location.X;
         YY := EventInfo.Location.Y;
         ImageBakule.Visible := true;
         ImageBakule.Position.X := EventInfo.Location.X - ((ImageBakule.Width * Image.Canvas.Scale) /2);
         ImageBakule.Position.Y := EventInfo.Location.Y - (ImageBakule.Height * Image.Canvas.Scale);
         Application.ProcessMessages;
         ActualNote := TTextElement.Create;
         ActualNote.X := GetModelX(EventInfo.Location.X);
         ACtualNote.Y := GetModelY(EventInfo.Location.Y);
         ActualNote.Name := S;
         dlg_Edit.Text := 'Poznmka ';
         dlg_Text.Text := 'Uloit poznmku pro '+S+':';
         dlg_General.Visible := true;
         dlg_Edit.SelectAll;
//         ShowMessage('Note');
//         ActiveTool := 0;
//         b_Note_Glow.Enabled := false;
      end
      else
      if CHeckJPRL then
      begin
         PSK := FindForestOnScreen(EventInfo.Location,true);
      end;
   end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
//   Edit1.Text := 'PaintBox '+ IntToStr(Round(PaintBox.Width))+'x'+IntToStr(Round(PaintBox.Height));
end;

function TMainForm.GetAbsolutePath(aRootPath, aRelativePath: string): string;
begin
   if aRootPath = '' then
      aRootPath := GetExecutablePath;
   result :=  System.IOUtils.TPath.Combine(aRootPath, aRelativePath);
end;

function TMainForm.GetExecutablePath: String;
begin
   result := Paramstr(0);
end;

function TMainForm.GetModelLength(aPageLength: single): System.Double;
begin
  Result:= aPageLength * MultX;
end;

function TMainForm.GetModelX(aPageX: single): System.Double;
begin
   Result:= MultX*aPageX + AddX ;
end;

function TMainForm.GetModelY(aPageY: single): System.Double;
begin
   Result:=  AddY-(MultY*aPageY);
end;

function TMainForm.GetPageLength(aModelLength: double): single;
begin
  result:= 0;
  if MultX = 0 then exit;
  try
    Result:= round(aModelLength / MultX);
{    Result:= round(ModelLength / UniMult); }
  except
  end
end;

function TMainForm.GetPageX(aModelX: double): single;
begin
  result:= 0;
  if MultX = 0 then exit;
  try
   Result:= (aModelX - AddX)/MultX;
  except
  end
end;

function TMainForm.GetPageY(aModelY: double): single;
begin
  result:= 0;
  if MultY = 0 then exit;
  try
   Result:= (AddY-aModelY)/MultY;
  except
  end
end;

function TMainForm.GetProc: TOwnerEntity;
begin
   if FProc = nil then
   begin
      FProc := TOwnerEntity.Create;
      FProc.Name := 'Processes';
   end;
   result := FProc;
end;

procedure TMainForm.b_NoteClick(Sender: TObject);
begin
   ActiveTool := 1;
   b_Note_Glow.Enabled := true;
   ActionPanel.Visible := true;
   l_Caption.Text := 'Reim vkldn/vbru poznmky';
   l_Text.Text := 'Drenm vlote nebo vyberte poznmku v map...'
end;

procedure TMainForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   S: string;
   i, ii: integer;
//   aShape: GpsShapeNET.Shape;
//   aDataRecord: GpsShapeNET.DataRecord;
//   aDataField:  GpsShapeNET.DataField;
   _X,_Y: double;
   JPRLChecked: boolean;
   JPRLResult: boolean;
   PSK: Tgis_PorostniSkupina;

begin
   i := ActiveTool;//c_Action.SelectedIndex;
   if i < 0 then i := 0;
   if i = 0 then exit; // gesta

   case i of
      1: //poznamka
      begin
//         if CheckJPRL and Assigned(FOnSelectJPRL) then
//            //FOnSelectJPRL(aOddeleni,aDilec,aPorost,aPSK);
//            FOnSelectJPRL(Self, nil);
         ShowMessage('Note');
         ActiveTool := 0;
         b_Note_Glow.Enabled := false;
      end;
      2: // editace linie
      begin
         Route_StartNew;
//         l_gps.Text := 'start';
         bmMoving := false;
//         ii := ActiveSubTool;
//         case ii of
//            0:
//            begin
////               objShape.NewNode(-1);
////               objShape.Position := objPosition;
//            end;
//            1:
//            begin
//
//            end;
//            2:
//            begin
//
//            end;
//         end;

//         map1.Update();
      end;
   end;
   // Center on mouse click

   //firstPos = null;
end;

procedure TMainForm.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Single);
var
   dX,sY: integer;
   _X,_Y: double;
   S: string;
   i: integer;
   SrcRect,DestRect: TRectF;
begin
//   if Test then Memo1.Lines.Add('M M');
//   exit;
//   if not BmPrepared then  exit;

   if BmMoving then exit;
   BmMoving := true;
   i := ActiveTool;//c_Action.SelectedIndex;
   case i of
      0:
      begin
      try
//      if PreparingMove then exit;
//      Memo1.Lines.Add('M M');

      if (LastLocalX = x) and (LastLocalY = Y)  then
      begin
         BmMoving := false;
         exit;
      end;
//      Memo1.Lines.Add('...Move');
      LastLocalX := X;
      LastLocalY := Y;
      _X := GetModelX(x);
      _Y := GetModelY(Y);
//      S := '0.##';
//      l_Coords.Text := 'x:'+FormatFloat(S,_X)+' y:'+FormatFloat(S,_Y);

      //l_xy.Text := e.x.ToString + ',' + e.Y.ToString;
      //G.Clear(0);
      //G.Clear(Color.WhiteSmoke);
      Image.Bitmap.Canvas.BeginScene;
      Image.Bitmap.Canvas.Clear(BColor);
      aX := X - LastX;
      aY := Y - LastY;
//      Image.Bitmap.Canvas.DrawLine(TPointF.Create(LastLocalX,LastLocalY),TPointF.Create(X,Y),100);
//      LastLocalX := X;
//      LastLocalY := Y;
      SrcRect.Create(0,0,Bm.Width,Bm.Height);
      DestRect.Create(aX,aY,aX + (Bm.Width / Image.Canvas.Scale),aY + (Bm.Height / Image.Canvas.Scale));
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      bmInMove := true;
      finally

      end;
      end;
      2:
      begin
         if (LastLocalX = x) and (LastLocalY = Y)  then
         begin
            BmMoving := false;
            exit;
         end;
   //      Memo1.Lines.Add('...Move');
         LastLocalX := X;
         LastLocalY := Y;
         _X := GetModelX(x);
         _Y := GetModelY(Y);
         Route_StoreCoords(_X,_Y,true);
         jtskX := _X;
         jtskY := _Y;
//         GpsFixed := true;
//         Drawgps;
         Application.ProcessMessages;
      end;
   end;
   BmMoving := false;
end;

procedure TMainForm.ImageMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Single);
var
   _X,_Y: double;
begin
//   if Test then Memo1.Lines.Add('M U');
//   exit;
   bmInMove := false;
   case ActiveTool of
      0:
      begin
        if Reviewing then exit;

      //   Memo1.Lines.Add( 'Up') ;
      //   Bm.DisposeOf;
      //   BmPrepared := false;
         RefX := RefX + aX;
         RefY := RefY + aY;
         _X := GetModelLength(aX);
         _Y := GetModelLength(aY);
         CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
         //G.Dispose;
         LastX := 0;
         LastY := 0;
         Review(false);
      end;
      2:
      begin
        Route_End;
//        l_gps.Text := 'END ...' ;
        gpsCursor.Visible := false;
      end;
   end;
   bmMoving := true;
   PreparingMove := false;
end;

procedure TMainForm.ImageResize(Sender: TObject);
begin
//   ShowMessage('resize');
//   Image.Bitmap.Canvas.BeginScene;

//   Image.Bitmap.Canvas.Clear(BColor);
//   Image.Bitmap.Canvas.EndScene;

   Image.Bitmap.Resize(Round(Image.Width * Image.Canvas.Scale),Round(Image.Height * Image.Canvas.Scale));
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Image.Bitmap.Width := Round(Image.Width);
//   Image.Bitmap.Height := Round(Image.Height);
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;
   CHangeProjection(CenterX,CenterY,RealScale);
   Review(false);
//   Edit1.Text := 'resize '+IntToStr(Round(Image.Width))+'x'+IntToStr(Round(Image.Height));
end;

procedure TMainForm.Image_editMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   i: integer;
begin
   if MLine = nil then
      MLine := TPolyLineElement.Create;
   MLine.AddXY(GetModelX(X),GetModelY(Y));
   Image_edit.Bitmap.Canvas.BeginScene;
   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
   Image_edit.Bitmap.Canvas.EndScene;
   DrawLine(MLine,true);
   l_Text.Text := 'Dlka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',MLine.Area/10000)+' ha';
   BMMoving := false;
end;

procedure TMainForm.Image_editMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);
var
   C: T2DCoordinate;
begin
   if BmMoving then exit;

   if MLine = nil then
      MLine := TPolyLineElement.Create;
   if MLine.NoElements then exit;
   C := MLine.GetOrientedCoordElement(MLine.LastIndex,true);
   C.X := GetModelX(X);
   C.Y := GetModelY(Y);
   Image_edit.Bitmap.Canvas.BeginScene;
   Image_edit.Bitmap.Canvas.Clear(TAlphaColors.Null);
   Image_edit.Bitmap.Canvas.EndScene;
   DrawLine(MLine,true);
   l_Text.Text := 'Dlka: '+FormatFloat('0.###',MLine.Length)+ ' m      Plocha:'+FormatFloat('0.##',MLine.Area/10000)+' ha';

end;

procedure TMainForm.Image_editMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   BMMoving := true;
end;

procedure TMainForm.LHCListboxItemClick(const Sender: TCustomListBox;
  const Item: TListBoxItem);
var
   SE: TStringElement;
begin
   SE := TStringElement(Item.Data);
   LoadProject(SE.Text);
end;

procedure TMainForm.LHC_Load;
var
   L: TLoad;
   i,ii: integer;
begin
//   exit;
//   ShowMessage('before det');
   if not System.IOUtils.TFile.Exists(LHCSPath) then
   begin
      if LHCS = nil then
      begin
         LHCS := TOwnerEntity.Create;
         LHCS.Name := 'LHCS';
      end;
      exit;
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'ten LHC z '+ LHCsPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(LHCsPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   LHCs := TOwnerEntity(L.Output);
   finally

   end;
   LHC_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.LHC_Save;
var
   S: TSave;
   i,ii: integer;
begin
//   exit;
//   ShowMessage('before det');
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Visible := true;
   l_Progress.Text := 'uloen LHC do '+ LHCSPath;
   l_Progress.Visible := false;
   Application.ProcessMessages;
   S := TSave.CreateAll(LHCsPath);
   try
   if LHCs = nil then
   begin
      LHCs := TOwnerEntity.Create;
      LHCS.Name := 'LHCS';
   end;
   S.NoProgress := true;
   S.Input := LHCs;
   S.DoIt;
   Except
   end;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.LHC_UpdateList;
var
  I: Integer;
  LI: TListBoxItem;
  SE: TStringElement;
begin
   LHCListbox.BeginUpdate;
   LHCListbox.Clear;
   if LHCs <> nil then
   begin
      for I := 0 to LHCs.LastIndex do
      begin
         SE := TStringElement(LHCs.Elements[i]);
         LI := TListBoxItem.Create(LHCListbox);
         LI.Text := SE.Name;
         LI.Data := SE;
         LI.ItemData.Detail := SE.Text;//FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bod';
         // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
//         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
         LI.StyleLookup := 'listboxitembottomdetail';
         LHCListbox.AddObject(LI);
      end;
   end;
   LHCListbox.EndUpdate;
end;

procedure TMainForm.LoadDET(aFileName, aOddName: string);
//var
//   S,SS: string;
//   iODD,IDIL,iPOR,iPSK,i,ii: integer;
//   MDCount,MXCount: integer;
//   MapRec : RMap;
//   MXRec  : RTileMatrix;
////   objRow : DataRow;
//   xLHC,xODD,xDIL,xPor,xPSK,n,DE,TMS: IXMLNode;
//   SLHC,SODD,SDIL,SPOR,SPSK: string;
//begin
//   exit;
//   l_Progress.Visible := true;
//   l_Progress.Text := aFileName;
//   Application.ProcessMessages;
//   XMLDOcument_lhc.Active := false;
//   XMLDocument_lhc.FileName := aFileName;
//   XMLDocument_lhc.Active := true;
//   xLHC := XMLDocument_lhc.DocumentElement;
//   SLHC := xLHC.Text;
//   ProgressBar.Min := 0;
//   ProgressBar.Max := xLHC.ChildNodes.Count - 1;
//   AniIndicator.Enabled := false;
//   AniIndicator.Visible := false;
//   ShowMessage('before odd');
//   for iODD  := 0 to xLHC.ChildNodes.Count - 1 do   // cteni map
//   begin
//      xODD := xLHC.ChildNodes[iODD];
//      ProgressBar.Value := iODD;
//      SS := xODD.Text;
//      l_Progress.Text := 'Pprava oddeleni ' + SS;
//      Application.ProcessMessages;
//      for iDIL := 0 to xODD.ChildNodes.Count -1 do
//      begin
//         xDIL := xODD.ChildNodes[iDIL];
//         sDIL := xDIL.Text;
//         for IPOR := 0 to xDIL.ChildNodes.Count - 1 do
//         begin
//             xPOR := xDIl.ChildNodes[iPOR];
//             sPOR := xPOR.Text;
//             for iPSK := 0 to xPOR.ChildNodes.Count - 1 do
//             begin
//                 xPSK := xPOR.ChildNodes[iPSK];
//                 sPSK := xPSK.Text;
//                 l_Progress.Text := 'Pprava oddeleni ' + sLHC+sODD+sDIL+sPOR+sPSK;
//                 Application.ProcessMessages;
//             end;
//         end;
//      end;
//   end;
//end;
//var
//   Tl: TTool;
//   i: integer;
//begin
////   exit;  // jumping
//   TL := TTechnology.Create;
//   ShowMessage('start');
//   TL.StartProgress('Testovaci progress',0,10);
//   for i := 0 to 10 do
//   begin
//       ShowMessage(IntTostr(i));
//       TL.Progress := i;
////       TL.ProgressText := 'test '+IntToStr(i);
//       Application.ProcessMessages;
//   end;
//   TL.EndProgress;
//end;

var
   L: TLoad;
   i,ii: integer;
   LS: Tgis_LS;
begin
//   exit;
//   ShowMessage('before det');
   if not System.IOUtils.TFile.Exists(aFilename) then
   begin
      ShowMessage('ten DET : soubor '+aFileName+' neexistuje!');
      exit;
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'ten DET z '+ aFileName;
   Application.ProcessMessages;
   L := TLoad.CreateAll(aFileName);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is Tgis_ForestModel) then exit;
   LHC := Tgis_ForestModel(L.Output);
   finally

   end;
   if LHC <> nil then
   begin
      LHC.ActualLHC := Tgis_LHC(LHC.FindElementClass(Tgis_LHC));
      //Oddeleni
      ed_odd.Items.Clear;
      if not LHC.ActualLHC.NoItems  then
      begin
         for i := 0 to LHC.ActualLHC.Items.LastIndex do
         begin
            LS := Tgis_LS(LHC.ActualLHC.Items.ForestUnit[i]);
            if not LS.NoItems then
            for ii := 0 to LS.Items.LastIndex do
            begin
               ed_odd.Items.Add(LS.Items.Elements[ii].Name);
               Application.ProcessMessages;
            end;
         end;
         ed_odd.ItemIndex := 0;
      end;
      FMSelector := TForestModelSelector.Create;
      FMSelector.ForestModel := LHC;
      FMSelector.ReferenceFrameClass := Tgis_PorostniSkupina;
      FMSelector.FrameClass := Tgis_PorostniSkupina;
   end;

   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.LoadEdit(aFileName: string);
begin

end;

procedure TMainForm.LoadMap(aFileName, aExt: string);
var
   S,SS: string;
   i,ii: integer;
   MDCount,MXCount: integer;
   MapRec : RMap;
   MXRec  : RTileMatrix;
//   objRow : DataRow;
   n,DE,TMS: IXMLNode;
begin
   if aFileName = ''  then
      exit;
   MapDirectory := IncludeTrailingPathDelimiter(aFileName);
   S := MapDirectory + 'Tiles.xml';
   if not (System.IOUtils.TFile.Exists(S)) then
   begin
      ShowMessage('Soubor '+ S + ' neexistuje!');
      exit;
   end
   else
   begin
      MapChangeActive := false;
      l_Progress.Text := 'ten mapovho souboru ...';
      AniIndicator.Visible := true;
      AniIndicator.Enabled := true;
      Application.ProcessMessages;
      // cteme dataset
      XMLDOcument.Active := false;
      XMLDocument.FileName := S;
      XMLDocument.Active := true;
      DE := XMLDocument.DocumentElement;
      MDCount := DE.ChildNodes.Count;
      SetLength(Maps, MDCount);
      ProgressBar.Min := 0;
      ProgressBar.Max := MDCount - 1;
      AniIndicator.Enabled := false;
      AniIndicator.Visible := false;
      MapCombo.Items.Clear;
      for i  := 0 to MDCount - 1 do   // cteni map
      begin
         N := DE.ChildNodes[i];
         ProgressBar.Value := i;
         SS := N.ChildNodes['name'].Text;
         l_Progress.Text := 'Pprava mapy ' + SS;
         Application.ProcessMessages;
         MapRec.MapName := N.ChildNodes['name'].Text;
         MapCombo.Items.Add(MapRec.MapName);
         MapRec.Ext := N.ChildNodes['ext'].Text;
         MapRec.MapDir := IncludeTrailingPathDelimiter(MapDirectory+ N.ChildNodes['dir'].Text);

         MapRec.MinX := 1E27;
         MapRec.MinY := 1E27;
         MapRec.MaxX := -1E27;
         MapRec.MaxY := -1E27;
//         MapRec.MapName :=  SS + '.' + aExt;
//         MapRec.Width := (MapRec.MaxX - MapRec.MinX);
//         MapRec.Height := (MapRec.MaxY - MapRec.MinY);
         TMS := N.ChildNodes['TileMatrixSet'];
         MXCount := TMS.ChildNodes.Count;
         SetLength(MapRec.TileMatrixSet,MXCount);
         for ii := 0 to MXCount - 1 do     // tilematrix
         begin
            N := TMS.ChildNodes[ii];
            MXRec.ID := N.ChildNodes['ID'].Text;
            MXRec.MinX := StrToIntDef(N.ChildNodes['MinX'].Text,0);
            MXRec.MinY := StrToIntDef(N.ChildNodes['MinY'].Text,0);
            MXRec.TileWidth := StrToIntDef(N.ChildNodes['TileWidth'].Text,0);
            MXRec.TileHeight := StrToIntDef(N.ChildNodes['TileHeight'].Text,0);
            MXRec.OverX := StrToIntDef(N.ChildNodes['OverX'].Text,0);
            MXRec.OverY := StrToIntDef(N.ChildNodes['OverY'].Text,0);
            MXRec.MatrixWidth := StrToIntDef(N.ChildNodes['MatrixWidth'].Text,0);
            MXRec.MatrixHeight := StrToIntDef(N.ChildNodes['MatrixHeight'].Text,0);
            if MXRec.MinX < MapRec.MinX then MapRec.MinX := MXRec.Minx;
            if MXRec.MinY < MapRec.MinY then MapRec.MinY := MXRec.MinY;
            MXRec.MaxX := MXRec.MinX + ((MXRec.MatrixWidth * MXRec.TileWidth) - ((MXRec.MatrixWidth - 1) * MXRec.OverX));
            MXRec.MaxY := MXRec.MinY + ((MXRec.MatrixHeight * MXRec.TileHeight) - ((MXRec.MatrixHeight - 1) * MXRec.OverY));
            MapRec.TileMatrixSet[ii] := MXRec;
            if MXRec.MaxX > MapRec.MaxX then MapRec.MaxX := MXRec.Maxx;
            if MXRec.MaxY > MapRec.MaxY then MapRec.MaxY := MXRec.MaxY;
         end;
         Maps[i] := MapRec;
      end;
      MapCombo.ItemIndex := 0;
      ActualMap := 0;
      ActualTileMatrix := 0;
   end;
end;

// original version ----------------------------------
//procedure TMainForm.LoadMap(aFileName, aExt: string);
//var
//   S,SS: string;
//   i: integer;
//   MDCount: integer;
//   MapRec : RMap;
////   objRow : DataRow;
//   n,DE: IXMLNode;
//begin
//   if aFileName = ''  then
//      exit;
//   MapDirectory := IncludeTrailingPathDelimiter(aFileName);
//   S := MapDirectory + 'Tiles.xml';
//   if not (System.IOUtils.TFile.Exists(S)) then
//   begin
//      ShowMessage('Soubor '+ S + ' neexistuje!');
//      exit;
//   end
//   else
//   begin
//      l_Progress.Text := 'ten mapovho souboru ...';
//      AniIndicator.Visible := true;
//      AniIndicator.Enabled := true;
//      Application.ProcessMessages;
//      // cteme dataset
//      XMLDOcument.Active := false;
//      XMLDocument.FileName := S;
//      XMLDocument.Active := true;
//      DE := XMLDocument.DocumentElement;
//      MDCount := DE.ChildNodes.Count;
//      SetLength(Maps, MDCount);
//      ProgressBar.Min := 0;
//      ProgressBar.Max := MDCount - 1;
//      AniIndicator.Enabled := false;
//      AniIndicator.Visible := false;
//      for i  := 0 to MDCount - 1 do
//      begin
//         N := DE.ChildNodes[i];
//         ProgressBar.Value := i;
//         SS := N.ChildNodes['TILE'].Text;
//         l_Progress.Text := 'Pprava mapy ' + SS;
//         Application.ProcessMessages;
//         MapRec.MinX := StrToIntDef(N.ChildNodes['minx'].Text,0);
//         MapRec.MinY := StrToIntDef(N.ChildNodes['miny'].Text,0);
//         MapRec.MaxX := StrToIntDef(N.ChildNodes['maxx'].Text,0);
//         MapRec.MaxY := StrToIntDef(N.ChildNodes['maxy'].Text,0);
//         MapRec.MapName :=  SS + '.' + aExt;
//         MapRec.Width := (MapRec.MaxX - MapRec.MinX);
//         MapRec.Height := (MapRec.MaxY - MapRec.MinY);
//         Maps[i] := MapRec;
//      end;
//   end;
//end;

procedure TMainForm.LoadProject(aFileName: string);
var
   S,sDir,sMap,sDET,sEdit,sOdd,sMapExt: string;
   i: integer;
begin
//   Refresh;
   LHCListpanel.Visible := false;
   Image.Enabled := true;
   MapChangeActive := false;
   LHC := nil;
   Routes := nil;
   Route_UpdateList;
   Notes := nil;
   Note_UpdateList;
   SetLength(Maps,0);
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;

   Application.ProcessMessages;
   OddListExists := false;
//  S := GetAbsolutePath('',aFileName);
   S := aFileName;
   sDir := TPath.GetDirectoryName(S);
   AlternativeRoutesPath := TPath.Combine(TPath.GetHomePath,(TPath.GetFileNameWithoutExtension(S)+'_RTS.orb'));
   RoutesPath := TPath.Combine(sDir,(TPath.GetFileNameWithoutExtension(S)+'_RTS.orb'));
   AlternativeNotesPath := TPath.Combine(TPath.GetHomePath,(TPath.GetFileNameWithoutExtension(S)+'_NTS.orb'));
   NotesPath := TPath.Combine(sDir,(TPath.GetFileNameWithoutExtension(S)+'_NTS.orb'));

//   if Routes_UseAlternative then
//      RoutesPath := TPath.Combine(TPath.GetHomePath,(TPath.GetFileNameWithoutExtension(S)+'_RTS.orb'))
//   else
//      RoutesPath := TPath.Combine(sDir,(TPath.GetFileNameWithoutExtension(S)+'_RTS.orb'));
   DBPath := SDir;
   {$IFDEF HK}
   Form2.OnSelectDir(DBPath);
   {$ENDIF}
   //MessageBox.Show('Before read');
   XMLDocument.FileName := S;
   XMLDocument.Active := true;
   //MessageBox.Show('After read');
   sMap := FindLayerPath('Map');
   sMapExt := FindLayerExt('Map');
   sDET := FindLayerPath('Det');
   S_rok := FindLayerValue('Det','rok');
   sEdit := FindLayerPath('Edit');
   sOdd := '';
   if sMap <> '' then
      sMap := GetAbsolutePath(sDir,sMap);
   if sDET <> '' then
   begin
      sDet := GetAbsolutePath(sDir,sDET);
      sOdd := System.IOUtils.TPath.ChangeExtension(sDet,'.odx');
   end;
   if sEdit <> '' then
   begin
      sEdit := GetAbsolutePath(sDir,sEdit);
   end;
   l_Progress.Visible := true;
   ProgressBar.Visible := true;
   Route_Load;
   Note_Load;
   if sDET <> '' then
      LoadDET(sDET,sOdd);
   LoadMap(sMap,sMapExt);
   LoadEdit(sEdit);
   l_Progress.Visible := false;
   ProgressBar.Visible := false;
   ChangeProjectionByFirstMapTile;
//   ShowMessage('BeforeReview');
   Review(false);
   MapChangeActive := true;
end;

procedure TMainForm.LocationSensorLocationChanged(Sender: TObject;  const OldLocation, NewLocation: TLocationCoord2D);
var
   S: string;
   A: TMapCoord;
begin
   gpsLat := NewLocation.Latitude;
   gpsLong := NewLocation.Longitude;
   WGS84toJTSK(gpsLat,gpsLong,A);
   jtskX := -A.Y;
   jtskY := -A.X;
   GPSFIxed := true;
   if GPSTrack then
   begin
      try
      Route_StoreCoords(jtskX,jtskY, false);
//      CHangeProjection(jtskX,jtskY,RealScale);
//      if not Reviewing then
//          Review(false);
      MainTool.PostMsg(tm_ReView,MainTool,ActualRoute,false);
      finally

      end;
   end;
   Drawgps;
//   Application.ProcessMessages;
   S := '0.###';
   l_jtsk.Text := 'X: '+FormatFloat(S,jtskX) + ' Y: '+FormatFloat(S,jtskY);
   l_gps.Text := WGS84ToStr(gpsLat,gpsLong);//+ '  A:'+FormatFloat(S,LocationSensor.Accuracy);
end;

procedure TMainForm.l_JPRLClick(Sender: TObject);
begin
   p_FInd.Visible := p_FInd.Visible;
end;

procedure TMainForm.MapComboChange(Sender: TObject);
begin
   if MapChangeActive then
   begin
      ActualMap := MapCombo.ItemIndex;
      Review(false);
   end;

end;

procedure TMainForm.Note_Load;
var
   L: TLoad;
   i,ii: integer;
   NPath: string;
begin
//   exit;
//   ShowMessage('before det');
   NPath := NotesPath;
   if not System.IOUtils.TFile.Exists(NPath) then
   begin
      NPath := AlternativeNotesPath;
      if not System.IOUtils.TFile.Exists(NPath) then
      begin
         exit;
      end;
      ShowMessage('Budou nateny poznmky uloen v intern pamti!');
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'ten Poznmek z '+ NotesPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(NPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   Notes := TOwnerEntity(L.Output);
   finally

   end;
   Note_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.Note_Save;
var
   S: TSave;
   i,ii: integer;
   NPath: string;
begin
//   exit;
//   ShowMessage('before det');
   NPath := NotesPath;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Visible := true;
   l_Progress.Text := 'uloen Poznmek do '+ NPath;
   l_Progress.Visible := false;
   Application.ProcessMessages;
   S := TSave.CreateAll(NPath);
   try
   S.NoProgress := true;
   S.Input := Notes;
   S.DoIt;
   Except
      ShowMessage('Nen mon zapsat poznmky k projektu - budou uloeny do intern pamti!');
      NotesPath  := AlternativeNotesPath;
      NPath := NotesPath;
      l_Progress.Text := 'uloen Poznmek do '+ NPath;
      l_Progress.Visible := false;
      Application.ProcessMessages;
      S := TSave.CreateAll(NPath);
      try
      S.NoProgress := true;
      S.Input := Notes;
      S.DoIt;
      except
         ShowMessage('Nen mon zapsat poznmky NIKAM!');
      end;
   end;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.Note_UpdateList;
var
  I: Integer;
  LI: TListBoxItem;
  T: TTextElement;
begin
   MiniLed_Notes_Form.NotesList.BeginUpdate;
   MiniLed_Notes_Form.NotesList.Clear;
   if Notes <> nil then
   begin
      for I := 0 to Notes.LastIndex do
      begin
         T := TTextElement(Notes.Elements[i]);
         LI := TListBoxItem.Create(MiniLed_Notes_Form.NotesList);
         LI.Text := T.Name;
         LI.Data := T;
         LI.ItemData.Detail := T.Text;//FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bod';
         // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
//         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
         LI.StyleLookup := 'listboxitembottomdetail';
         MiniLed_Notes_Form.NotesList.AddObject(LI);
      end;
   end;
   MiniLed_Notes_Form.NotesList.EndUpdate;
end;

procedure TMainForm.OnProgress(_ID, _Event: integer; _Name, _Text: string;
  _MinValue, _MaxValue, _Progress: integer);
begin
   case _Event  of
      tm_StartProgress:
            Orbis_ProgressStart(_ID,_Name,_MinValue,_MaxValue,_MinValue);
      tm_EndProgress:
            Orbis_ProgressEnd(_ID,0);
      tm_Progress:
            Orbis_Progress(_ID,_Progress);
      tm_MaxProgress:
            Orbis_ProgressMax(_ID,_MaxValue);
   else
         Orbis_ProgressText(_ID, _Text);
   end;
end;

procedure TMainForm.OnSelectFile(const S: string);
begin
//   l_Scale.Text := S;
   //XFileDialog.Close;
//   Application.ProcessMessages;
{$IFDEF HK}
   AddProject(S);
{$ELSE}
   LoadProject(S);
{$ENDIF}
end;

procedure TMainForm.Orbis_Progress(_ID, Value: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   P.Progress := Value;
   if _ID <> ActiveProgress  then
   begin
      ActiveProgress := _ID;
      ProgressBar.Min := P.Min;
      ProgressBar.Max := P.Max;
   end;
   ProgressBar.Value := P.Progress;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressEnd(_ID, Value: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   Proc.ElementToFree := P;
   ActiveProgress := 0;
   ProgressBar.Value := 0;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressMax(_ID, Value: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   P.Max := Value;
   if _ID <> ActiveProgress  then
   begin
      ActiveProgress := _ID;
      ProgressBar.Min := P.Min;
      ProgressBar.Value := P.Progress;
   end;
   ProgressBar.Max := P.Max;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressStart(_ID: Integer; ProgressName: string;
  MinProgress, MaxProgress, Progress: Integer);
var
   P: TProgressElem;
begin
   P := TProgressElem.Create;
   P._ID := _ID;
   P._Name := ProgressName;
   P.Min := MinProgress;
   P.Max := MaxProgress;
   P.Progress := Progress;
   P.Name := IntToStr(_ID);
   Proc.NextElement := P;
   ActiveProgress := _ID;
   ProgressBar.Min := MinProgress;
   ProgressBar.Max := MaxProgress;
   ProgressBar.Value := MinProgress;
   CheckProgress;
end;

procedure TMainForm.Orbis_ProgressText(_ID: Integer; Value: string);
var
   P: TProgressElem;
begin
   P := TProgressElem(Proc.FindElementName(IntToStr(_ID)));
   P.Text := Value;
   CheckProgress;
end;

procedure TMainForm.Review(compact: boolean);
var
   i,Xi,Yi,xi1,xi2,yi1,yi2: integer;
   X1,Y1,X2,Y2: double;
   Revi: integer;
   Maprec: RMap;
   MX: RTileMatrix;
   S: string;
   bm1: TBitmap;
   DestRect,SrcRect: TRectf;
   dX: Single;
begin
   Reviewing := true;
   Revi := StopReviews;
   Reviews[Revi] := 1;
   //G.Clear(System.Drawing.Color.WhiteSmoke);
    Application.ProcessMessages;
    if Compact then
    begin
       Image.Bitmap.Canvas.BeginScene;
       Image.Bitmap.Canvas.Clear(BColor);
    end;
    // nalezeni spravneho Tilematrix pro projekci
    MapRec := Maps[ActualMap];
    for i := 0 to Length(MapRec.TileMatrixSet) - 1 do
    begin
       MX := MapRec.TileMatrixSet[i];
       ActualTileMatrix := i;
       dx := GetPageLength(MX.TileWidth);
       if dx <= 500 then break;
    end;
    MX := MapRec.TileMatrixSet[ActualTileMatrix];
//    Edit1.Text := MX.ID;

    X1 := MX.MinX;
    if x1 < MinX then
    begin
       xi1 := Trunc((Minx - X1) / (MX.TileWidth - MX.OverX));
       X1 := X1 + (xi1 * (MX.TileWidth - MX.OverX));
    end
    else
    begin
       xi1 := 0;
    end;
    X2 := X1 + MX.TileWidth;
    for Xi := xi1 to MX.MatrixWidth - 1 do
    begin
       Y1 := MX.MinY;
       if y1 < MinY then
       begin
          yi1 := Trunc((Miny - y1) / (MX.TileHeight - MX.OverY));
          Y1 := Y1 + (yi1 * (MX.TileHeight - MX.OverY));
       end
       else
       begin
          yi1 := 0;
       end;
       Y2 := Y1 + MX.TileHeight;
       for Yi := yi1 to MX.MatrixHeight - 1 do
       begin
//          ShowReviews('til'+IntToStr(Revi));
//          Application.ProcessMessages;
//          if Reviews[Revi] = 2 then     //stop
//          begin
//             Reviews[Revi] := 0;
//             DrawGPS;
//             Bm.CopyFromBitmap(Image.Bitmap);
////             ShowReviews('break');
//             exit;
//          end;

          if (X1 < MaxX) and (Y1 < MaxY) and
             (X2 > MinX) and (Y2 > MinY)then
          begin
             S := MapRec.MapDir + MX.ID + '_'+IntToStr(Xi)+'-'+IntToStr(Yi)+'.'+MapRec.Ext;
             try
             if not compact then
                Image.Bitmap.Canvas.BeginScene;
             Bm1 := TBitmap.CreateFromFile(S);   // hodit do live array
             SrcRect  := TRectF.Create(0,0,Bm1.Width,Bm1.Height);
             DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y2),GetPageX(X2),GetPageY(Y1));
             Image.Bitmap.Canvas.DrawBitmap(Bm1,SrcRect,DestRect,100);
             if not Compact then
             begin
                Image.Bitmap.Canvas.EndScene;
                Application.ProcessMessages;
             end;
             Bm1.DisposeOf;
             //PictureBox1.Image := System.Drawing.Bitmap.Create(S);
             finally
                //G.Dispose;
             end;
          end;
          Y1 := Y2 - MX.OverY;
          if Y1 > MaxY then Break;
          Y2 := Y1 + MX.TileHeight;
       end;
       X1 := X2 - MX.OverX;
       if X1 > MaxX then Break;
       X2 := X1 + MX.TileWidth;
    end;

//    for i := 0 to Length(Reviews) - 1 do
//    begin
//       if Reviews[Revi] = 2 then
//       begin
//          Reviews[Revi] := 0;
//          Application.ProcessMessages;
//          exit;
//       end;
//
//    end;
    Reviews[Revi] := 0;
    if Compact then
    begin
       Image.Bitmap.Canvas.EndScene;
       Application.ProcessMessages;
    end;
   DrawRoutes;
   DrawNotes;
   DrawGPS;
   Bm.CopyFromBitmap(Image.Bitmap);
   Reviewing := false;
//   ShowReviews('tend');
end;

procedure TMainForm.RoutesListItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
var
   L: TPolyLineElement;
begin
   if Item = nil  then exit;
   if Item.Data = nil then exit;
   if not (Item.Data is TPolyLineElement) then exit;
   L := TPolyLineElement(Item.Data);
   L.Update;
   CHangeProjectionByRect(L.MinX,L.MinY,L.MaxX,L.MaxY);
   if RealScale < 2000 then
      CHangeProjection(CenterX,CenterY,2000);
   Review(false);
   BlinkLine(L);

end;

procedure TMainForm.Route_End;
begin
   GPSTrack := false;
end;

procedure TMainForm.Route_Load;
var
   L: TLoad;
   i,ii: integer;
   RPath: string;
begin
//   exit;
//   ShowMessage('before det');
   RPath := RoutesPath;
   if not System.IOUtils.TFile.Exists(RPath) then
   begin
      RPath := AlternativeRoutesPath;
      if not System.IOUtils.TFile.Exists(RPath) then
      begin
         exit;
      end;
      ShowMessage('Budou nateny trasy uloen v intern pamti!');
   end;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Text := 'ten Tras z '+ RoutesPath;
   Application.ProcessMessages;
   L := TLoad.CreateAll(RPath);
   L.NoProgress := true;
   try
   L.DoIt;
   if not(L.output is TOwnerEntity) then exit;
   Routes := TOwnerEntity(L.Output);
   finally

   end;
   Route_UpdateList;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.Route_Save;
var
   S: TSave;
   i,ii: integer;
   RPath: string;
begin
//   exit;
//   ShowMessage('before det');
   RPath := RoutesPath;
   AniIndicator.Visible := true;
   AniIndicator.Enabled := true;
   l_Progress.Visible := true;
   l_Progress.Text := 'uloen Tras do '+ RPath;
   l_Progress.Visible := false;
   Application.ProcessMessages;
   S := TSave.CreateAll(RPath);
   try
   S.NoProgress := true;
   S.Input := Routes;
   S.DoIt;
   Except
      ShowMessage('Nen mon zapsat trasy k projektu - budou uloeny do intern pamti!');
      RoutesPath  := AlternativeRoutesPath;
      RPath := RoutesPath;
      l_Progress.Text := 'uloen Tras do '+ RPath;
      l_Progress.Visible := false;
      Application.ProcessMessages;
      S := TSave.CreateAll(RPath);
      try
      S.NoProgress := true;
      S.Input := Routes;
      S.DoIt;
      except
         ShowMessage('Nen mon zapsat trasy NIKAM!');
      end;
   end;
   AniIndicator.Visible := false;
   AniIndicator.Enabled := false;
end;

procedure TMainForm.Route_ShowList;
begin

end;

procedure TMainForm.Route_StartNew;
begin
   if Routes = nil then
   begin
      Routes := TOwnerEntity.Create;
      Routes.Name := 'Routes';
   end;
   ActualRoute := TPolyLineElement.Create;
   Routes.AddElement(ActualRoute);
   GPSTrack := true;
end;

procedure TMainForm.Route_StoreCoords(gx, gy: double; Redraw: boolean);
begin
   if ActualRoute  = nil then
   begin
//      Label9.Text := 'NIL';
      exit;
   end;
   ActualRoute.AddXY(gx,gy);
//   Label9.Text := 'L'+IntToStr(ActualRoute.CoordsCount);
   if Redraw then
      DrawLine(ActualRoute,false);
end;

procedure TMainForm.Route_UpdateList;
var
  I: Integer;
  LI: TListBoxItem;
  L: TPolyLineElement;
begin
   MiniLed_Notes_Form.RoutesList.BeginUpdate;
   MiniLed_Notes_Form.RoutesList.Clear;
   if Routes <> nil then
   begin
      for I := 0 to Routes.LastIndex do
      begin
         L := TPolyLineElement(Routes.Elements[i]);
         LI := TListBoxItem.Create(MiniLed_Notes_Form.RoutesList);
         LI.Text := L.Name;
         LI.Data := L;
         LI.ItemData.Detail := FormatFloat('0.##',L.Length)+' m '+IntToStr(L.Count)+' bod';
         // (aNone=0, aMore=1, aDetail=2, aCheckmark=3)
//         LI.ItemData.Accessory := TListBoxItemData.TAccessory(2);
         LI.StyleLookup := 'listboxitembottomdetail';
         MiniLed_Notes_Form.RoutesList.AddObject(LI);
      end;
   end;
   MiniLed_Notes_Form.RoutesList.EndUpdate;
end;

procedure TMainForm.SetActiveProgress(const Value: integer);
begin
  FActiveProgress := Value;
end;

procedure TMainForm.SetOnSelectJPRL(const Value: TNotifyEvent);
begin
   FOnSelectJPRL := Value;
end;

procedure TMainForm.SetProc(const Value: TOwnerEntity);
begin
  FProc := Value;
end;

procedure TMainForm.set_GPSFixed(const Value: boolean);
begin
  FGPSFixed := Value;
end;


procedure TMainForm.ShowScaleAndCoords;
var
   S: string;
begin
   l_Scale.Text := '1 : ' + IntToStr(Round(RealScale));
   S := '0.###';
   l_jtsk.Text := 'X: '+FormatFloat(S,CenterX) + ' Y: '+FormatFloat(S,CenterY);
end;

procedure TMainForm.ShowTheForest;
var
   FU: Tgis_ForestUnit;
begin
   LHC.ActualLS := nil;
   LHC.Oddeleni_Cislo := StrToIntDef(S_Oddeleni,0);
   LHC.Dilec_Name := S_Dilec;
   LHC.Porost_Name := S_Porost;
   LHC.Skupina_Name := S_Skupina;
   FU := LHC.ActualSkupina;
   if FU = nil then
      FU := LHC.ActualPorost;
   if FU = nil then
      FU := LHC.ActualDilec;
   if FU = nil then
      FU := LHC.ActualOddeleni;
   if FU = nil then
      FU := LHC.ActualLHC;
   if FU <> nil  then
   begin
      CHangeProjectionByRect(FU.MinX,FU.MinY,FU.MaxX,FU.MaxY);
      if RealScale  < 2000 then
      begin
          CHangeProjection(CenterX,CenterY,2000);
      end;
      Review(false);
   end;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
   case ActiveTool of
      0: ActiveTool := 2;
   else
      ActiveTool := 0;
   end;
end;

function TMainForm.StopReviews: integer;
var
   i,ii: integer;
   val: integer;
begin
   result := -1;
   ii := 0;
   for i := 0 to Length(Reviews) - 1 do
   begin
      val := Reviews[i];
      if (result < 0) and (val = 0) then
         result := i
      else
      if val = 1 then
      begin
         Reviews[i] := 2;
         ii := ii + 1;
      end;
   end;
//   ShowReviews('stop');
   Application.ProcessMessages;
//   l_Coords.Text := ii.ToString;
end;


{ TProgressElem }

procedure TProgressElem.SetMax(const Value: integer);
begin
   FMax := value;
end;

procedure TProgressElem.SetMin(const Value: integer);
begin
   FMin := Value;
end;

procedure TProgressElem.SetProgress(const Value: integer);
begin
   FProgress := Value;
end;

procedure TProgressElem.SetText(const Value: string);
begin
   FText := value;
end;

procedure TProgressElem.Set_ID(const Value: integer);
begin
   F_ID := Value;
end;

procedure TProgressElem.Set_Name(const Value: string);
begin
   F_Name := value;
end;

{ TMainTool }

procedure TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_ReView       : On_tm_ReView(aMessage, Handled);
   end;
end;

procedure TMainTool.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   if aMessage.Data <> nil then
   begin
      MainForm.DrawLine(MainForm.ActualRoute,false);
   end
   else
   begin
      MainForm.Review(false);
   end;
end;

end.
