/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package applet;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.IOException;
import static java.lang.Math.round;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 *
 * @author miniexot
 */
public class Projection {

    double CenterX, CenterY, RealScale, Scale1,
            MinX, MinY, MaxX, MaxY, MultX, MultY,
            AddX, AddY, X1, Y1, X2, Y2, mapWidth, mapHeight;
    int actualTileMatrix;
    Thread activeThread;

    public Projection(double mapWidth, double mapHeight) {
        this.mapWidth = mapWidth;
        this.mapHeight = mapHeight;
        this.CenterX = -1;
        this.CenterY = -1;
        this.RealScale = -1;
        this.Scale1 = -1;
        this.MinX = -1;
        this.MinY = -1;
        this.MaxX = -1;
        this.MaxY = -1;
        this.MultX = -1;
        this.MultY = -1;
        this.AddX = -1;
        this.AddY = -1;
        this.X1 = -1;
        this.Y1 = -1;
        this.X2 = -1;
        this.Y2 = -1;
        this.actualTileMatrix = 0;

    }

    public void stopThread() {
        activeThread.setName("umri");
        activeThread = null;
    }

    public void Review(final MapData actualMap, final Mapa mapa1) {

        Thread thread = new Thread("mapa") {

            @Override
            public void run() {

                activeThread = this;

                int i, Xi, Yi, xi1, xi2, yi1, yi2, Revi, dx;
                double X1, Y1, X2, Y2;
                int[] MX;
                String S;
                URL url;

                // nalezeni spravneho Tilematrix pro projekci
                for (int x = 0; x < actualMap.getTileMatrixData().size(); x++) {

                    actualTileMatrix = x;
                    dx = GetPageLength(actualMap.getTileMatrixData().get(x)[2]);
                    if (dx <= 500) {
                        break;
                    }
                }
                MX = actualMap.getTileMatrixData().get(actualTileMatrix);

                X1 = MX[0];
                if (X1 < MinX) {
                    xi1 = (int) ((MinX - X1) / (MX[2] - MX[4]));
                    X1 = X1 + (xi1 * (MX[2] - MX[4]));
                } else {
                    xi1 = 0;
                }

                X2 = X1 + MX[2];

                BufferedImage off_Image
                        = new BufferedImage(mapa1.getWidth(), mapa1.getHeight(),
                                BufferedImage.TYPE_INT_RGB);

                Graphics g2 = off_Image.getGraphics();

                for (Xi = xi1; Xi < MX[6]; Xi++) {
                    if (this.getName().equalsIgnoreCase("umri")) {
                        break;
                    }
                    Y1 = MX[1];
                    if (Y1 < MinY) {
                        yi1 = (int) ((MinY - Y1) / (MX[3] - MX[5]));
                        Y1 = Y1 + (yi1 * (MX[3] - MX[5]));
                    } else {
                        yi1 = 0;
                    }
                    Y2 = Y1 + MX[3];
                    for (Yi = yi1; Yi < MX[7]; Yi++) {
                        if (this.getName().equalsIgnoreCase("umri")) {
                            break;
                        }
                        if ((X1 < MaxX) && (Y1 < MaxY)
                                && (X2 > MinX) && (Y2 > MinY)) {
                            S = actualMap.getIDs().get(actualTileMatrix) + "_" + Xi + "-" + Yi + "." + actualMap.getExt();
                            try {

                                url = new URL("http://www.tpro.cz/heletax/LHC_Jablonec/Mapy/" + actualMap.getDir() + "/" + S);
                                url.openConnection().setUseCaches(true);
                                BufferedImage image = ImageIO.read(url);
                                g2.drawImage(image, GetPageX(X1), GetPageY(Y2), GetPageX(X2) - GetPageX(X1), GetPageY(Y1) - GetPageY(Y2), mapa1);
                                //mapa1.paintCtverecek(image, GetPageX(X1), GetPageY(Y2),GetPageX(X2),GetPageY(Y1));
                                if (this.getName().equalsIgnoreCase("umri")) {
                                    break;
                                }
                                mapa1.paintCtverecek(off_Image, 0, 0);
                            } catch (MalformedURLException ex) {
                                Logger.getLogger(Projection.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IOException ex) {
                                Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, null, ex);
                            }
                            Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "TILE MATRIX CURRENT: " + Xi + ";" + Yi + ": " + GetPageX(X1) + ";" + GetPageY(Y2) + " - " + GetPageX(X2) + ";" + GetPageY(Y1));

                        }
                        Y1 = Y2 - MX[5];
                        if (Y1 > MaxY) {
                            break;
                        }
                        Y2 = Y1 + MX[3];

                    }
                    X1 = X2 - MX[4];
                    if (X1 > MaxX) {
                        break;
                    }
                    X2 = X1 + MX[2];
                }
            }
        };

        thread.start();

    }

    public void ChangeProjectionByFirstMapTile(MapData firstMap) {

        X1 = firstMap.getMinX();
        Y1 = firstMap.getMinY();
        X2 = firstMap.getMaxX();
        Y2 = firstMap.getMaxY();

        ChangeProjectionByRect(X1, Y1, X2, Y2);
        Scale1 = RealScale;
    }

    public void ChangeProjectionByRect(double X1, double Y1, double X2, double Y2) {

        double _x, _y, _Scale, ScaleX, ScaleY, dX, dY;

        dX = X2 - X1;
        dY = Y2 - Y1;

        ScaleX = dX / (this.mapWidth / 5333);
        ScaleY = dY / (this.mapHeight / 5333);
        if (ScaleX > ScaleY) {
            _Scale = ScaleX;
        } else {
            _Scale = ScaleY;
        }
        _x = X1 + dX / 2;
        _y = Y1 + dY / 2;
        ChangeProjection(_x, _y, _Scale);

    }

    public void ChangeProjection(double _X, double _Y, double _Scale) {

        double Center_X, Center_Y, W, H;

        CenterX = _X;
        CenterY = _Y;
        RealScale = _Scale;
        W = this.mapWidth;
        H = this.mapHeight;
        Center_X = W / 2;
        Center_Y = H / 2;
        MultX = RealScale / 5333; //Resolution.x; dpi / size of inch in mm * 1000
        MultY = MultX;
        AddX = CenterX - (Center_X * MultX);
        AddY = CenterY + (Center_Y * MultY);
        MinX = GetModelX(0);
        MinY = GetModelY(H);
        MaxX = GetModelX(W);
        MaxY = GetModelY(0);

    }

    int GetPageX(double aModelX) {
        if (MultX == 0) {
            return 0;
        }

        return Math.round((float) ((aModelX - AddX) / MultX));

    }

    int GetPageY(double aModelY) {
        if (MultY == 0) {
            return 0;
        }

        return Math.round((float) ((AddY - aModelY) / MultY));

    }

    double GetModelLength(double aPageLength) {

        return aPageLength * MultX;

    }

    double GetModelX(double aPageX) {
        return MultX * aPageX + AddX;
    }

    double GetModelY(double aPageY) {
        return AddY - (MultY * aPageY);
    }

    int GetPageLength(int aModelLength) {

        if (MultX == 0) {
            return -1;
        }

        return Math.round((float) (aModelLength / MultX));

    }

    public double getMapWidth() {
        return mapWidth;
    }

    public void setMapWidth(double mapWidth) {
        this.mapWidth = mapWidth;
    }

    public double getMapHeight() {
        return mapHeight;
    }

    public void setMapHeight(double mapHeight) {
        this.mapHeight = mapHeight;
    }

    public double getCenterX() {
        return CenterX;
    }

    public void setCenterX(double CenterX) {
        this.CenterX = CenterX;
    }

    public double getCenterY() {
        return CenterY;
    }

    public void setCenterY(double CenterY) {
        this.CenterY = CenterY;
    }

    public double getRealScale() {
        return RealScale;
    }

    public void setRealScale(double RealScale) {
        this.RealScale = RealScale;
    }

    public double getScale1() {
        return Scale1;
    }

    public void setScale1(double Scale1) {
        this.Scale1 = Scale1;
    }

    public double getMinX() {
        return MinX;
    }

    public void setMinX(double MinX) {
        this.MinX = MinX;
    }

    public double getMinY() {
        return MinY;
    }

    public void setMinY(double MinY) {
        this.MinY = MinY;
    }

    public double getMaxX() {
        return MaxX;
    }

    public void setMaxX(double MaxX) {
        this.MaxX = MaxX;
    }

    public double getMaxY() {
        return MaxY;
    }

    public void setMaxY(double MaxY) {
        this.MaxY = MaxY;
    }

    public double getMultX() {
        return MultX;
    }

    public void setMultX(double MultX) {
        this.MultX = MultX;
    }

    public double getMultY() {
        return MultY;
    }

    public void setMultY(double MultY) {
        this.MultY = MultY;
    }

    public double getAddX() {
        return AddX;
    }

    public void setAddX(double AddX) {
        this.AddX = AddX;
    }

    public double getAddY() {
        return AddY;
    }

    public void setAddY(double AddY) {
        this.AddY = AddY;
    }

    public double getX1() {
        return X1;
    }

    public void setX1(double X1) {
        this.X1 = X1;
    }

    public double getY1() {
        return Y1;
    }

    public void setY1(double Y1) {
        this.Y1 = Y1;
    }

    public double getX2() {
        return X2;
    }

    public void setX2(double X2) {
        this.X2 = X2;
    }

    public double getY2() {
        return Y2;
    }

    public void setY2(double Y2) {
        this.Y2 = Y2;
    }

    public int getActualTileMatrix() {
        return actualTileMatrix;
    }

    public void setActualTileMatrix(int actualTileMatrix) {
        this.actualTileMatrix = actualTileMatrix;
    }

    public void vypisProjekce() {

        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "Vypis projekce: \n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "mapWidth: " + this.mapWidth + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "mapHeight: " + this.mapHeight + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "CenterX: " + this.CenterX + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "CenterY: " + this.CenterY + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "RealScale: " + this.RealScale + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "Scale1: " + this.Scale1 + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "MinX: " + this.MinX + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "MinY: " + this.MinY + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "MaxX: " + this.MaxX + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "MaxY: " + this.MaxY + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "MultX: " + this.MultX + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "MultY: " + this.MultY + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "AddX: " + this.AddX + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "AddY: " + this.AddY + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "X1: " + this.X1 + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "Y1: " + this.Y1 + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "X2: " + this.X2 + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "Y2: " + this.Y2 + "\n");
        Logger.getLogger(HeletaxGUI.class.getName()).log(Level.SEVERE, "actualTileMatrix: " + this.actualTileMatrix + "\n");

    }
}
